

clear all;
close all;

rng_arr_max=1;
rng_arr=1:1:rng_arr_max;

for ti_rng_scan=1:1:length(rng_arr)
    
    rng_sim=rng_arr(ti_rng_scan);

init_param_set;

%% Arbitrary
[cand_pos_num,rr_vec_cand,cand_kk_num,kk_range_set_target,theta_grid,theta_grid_k,theta_cand,theta_cand_k,rr_cand_del,rr_cand_del_kk,rr_cand_del_fit,rr_cand_del_kk_fit,f_rr_cand_del,f_kk_cand_del,rr_cand,rr_cand_kk,RR_ROI_max_arr,RR_ROI_min_arr,kk_ROI_max_arr,kk_ROI_min_arr]=...
monte_carlo_setting_arbitrary(monte_num_RR_max,monte_num_km_max,VV_ROI,VV_max,VV_ROI_kk,VV_max_kk,ang_rr_st,ang_rr_ed,ang_kk_st,ang_kk_ed,pdf_approx_discrete,DD,rr_vec_init,RR_ROI_min,RR_ROI_max,kk_ROI_min,kk_ROI_max);
%    
% [cand_pos_num,rr_vec_cand,cand_kk_num,kk_range_set_target,theta_grid,theta_grid_k,theta_cand,theta_cand_k,rr_cand_del,rr_cand_del_kk,rr_cand_del_fit,rr_cand_del_kk_fit,f_rr_cand_del,f_kk_cand_del,rr_cand,rr_cand_kk]=...
% monte_carlo_setting(monte_num_RR_max,monte_num_km_max,VV_ROI,VV_max,VV_ROI_kk,VV_max_kk,ang_rr_st,ang_rr_ed,ang_kk_st,ang_kk_ed,pdf_approx_discrete,DD,rr_vec_init,RR_ROI_min,RR_ROI_max,kk_ROI_min,kk_ROI_max);
%    
%% Optimization Process
if method_param==1     %% Monte Carlo Method 
    
    %% Monte-Carlo Method
    cost_func_monitor_arr=zeros(NN,1);
    rho_func_prev=0;
    rho_func_prev_arr=zeros(round(monte_num_RR_max.*(VV_ROI./VV_max)),NN);
    weight_degree_arr=zeros(NN,NN);
    preference_ele_arr=zeros(NN,NN);
    for ti_NN=(NN_pre+1):1:NN
        if mod(ti_NN,200)==0
            ['Process = ',num2str((ti_NN-2)./(NN-2).*100),'%']
        end
        NN_curr=(ti_NN-1);  
        if prefer_const==1    %% Static Preference
            [rr_vec,cost_func_monitor,rho_func]=generative_function_MC_prefer_static(rr_vec,NN_curr,rr_vec_cand,kk_range_set_target,HU_aHU,rho_func_prev,fff_prefer);
        else    %% Updating Preference based on Evolving Weight Networks 
            [rr_vec,cost_func_monitor,rho_func,weight_degree,preference_ele]=generative_function_MC_prefer_dynamic(rr_vec,NN_curr,rr_vec_cand,kk_range_set_target,HU_aHU,prefer_type);
            weight_degree_arr(1:1:NN_curr,ti_NN)=weight_degree;
            preference_ele_arr(1:1:NN_curr,ti_NN)=preference_ele;
        end
        rho_func_prev=rho_func;
        rho_func_prev_arr(:,ti_NN)=rho_func_prev;
        cost_func_monitor_arr(ti_NN)=cost_func_monitor;
    end
    NN_curr=NN_curr+1;    
    
elseif method_param==2    
    
    %% Gradient Descent Algorithm
    GD_factor_init=1e-6;
    GD_factor_min=1e-8;
    GD_max_iter=200;
    GD_change_limit=50;
    cost_monitor=1;
    err_code_arr=zeros(1,NN-1);
    GD_iter_num_arr=zeros(1,NN-1);
    for ti_NN=2:1:NN
        if mod(ti_NN,10)==0
            ['Process = ',num2str((ti_NN-2)./(NN-2).*100),'%']
        end
        NN_curr=(ti_NN-1);
        [rr_vec,rr_vec_update_arr,GD_factor_update_arr,GD_grad_f_term_arr,GD_iter_num,rho_func,err_code]=generative_function_GD(rr_vec,NN_curr,rr_vec_cand,kk_range_set_target,RR_max,GD_factor_init,GD_factor_min,GD_max_iter,GD_change_limit,HU_aHU,cost_monitor);
        err_code_arr(ti_NN-1)=err_code;
        GD_iter_num_arr(ti_NN-1)=GD_iter_num;
    end
    
else
    
end

%% Structural Factor Calculation
kk_del_fac=0.1;
[SS_k,kk_range_set,kk_range_axis,kk_del,kk_axis_num,kk_comb_num]=structure_factor_specific(rr_vec,kk_max,RR_max,kk_del_fac);
['S-Factor END!']

%% 2D Conversion
SS_k_2D=reshape(SS_k,kk_axis_num(1),kk_axis_num(2));
[kk_range_axis_grid{1},kk_range_axis_grid{2}]=meshgrid(kk_range_axis{1},kk_range_axis{2});
kk_range_rr_grid=sqrt(kk_range_axis_grid{1}.^2+kk_range_axis_grid{2}.^2);
kk_ROI_ind=(kk_range_rr_grid>=kk_ROI_min)&(kk_range_rr_grid<=kk_ROI_max);
kk_max_ind=(kk_range_rr_grid<=kk_max);

%% Saving Data Files
if NN_pre<2
    data_file_name=['./Data/Pref_',num2str(prefer_const),'_Type_',num2str(prefer_type,'%02i'),'_HU_',num2str(HU_aHU),'_NN_',num2str(NN,'%05i'),'_k_max_',num2str(round(1e2.*km_ROI_max),'%03i'),'_min_',num2str(round(1e2.*km_ROI_min),'%03i'),'_rng_',num2str(rng_param,'%03i')]
else
    data_file_name=['./Data/Pref_',num2str(prefer_const),'_Type_',num2str(prefer_type,'%02i'),'_HU_',num2str(HU_aHU),'_NN_',num2str(NN,'%05i'),'_k_max_',num2str(round(1e2.*km_ROI_max),'%03i'),'_min_',num2str(round(1e2.*km_ROI_min),'%03i'),'_NN_pre_',num2str(NN_pre,'%05i'),'_R_init_max_',num2str(round(1e2.*RR_init_max),'%03i'),'_min_',num2str(round(1e2.*RR_init_min),'%03i'),'_rng_',num2str(rng_param,'%03i')]
end
save(data_file_name);

end
    



