
function [rr_vec,cost_func_monitor,rho_func]=generative_function_MC_prefer_static(rr_vec,NN_curr,rr_vec_cand,kk_range_set_target,HU_aHU,rho_func_prev,fff_prefer)

%% Structural Parameters
temp=size(rr_vec);
NN=temp(1);
DD=temp(2);
sz_kk_range_set=size(kk_range_set_target);
kk_range_set_num=sz_kk_range_set(1);

%% Original Code
% rho_func=rho_func_prev.*(NN_curr-1);
% for ti_kk_target=1:1:kk_range_set_num
%     rho_func=rho_func+cos(sum(kk_range_set_target(ti_kk_target,:).*(rr_vec(NN_curr,:)-rr_vec_cand(:,:)),2));
% end

temp_val=0;
for ti_kk_target=1:1:kk_range_set_num
    temp_val=temp_val+2.*fff_prefer(NN_curr).*cos(sum(kk_range_set_target(ti_kk_target,:).*(rr_vec(NN_curr,:)-rr_vec_cand(:,:)),2));
end
rho_func=(NN_curr.*rho_func_prev+temp_val./kk_range_set_num)./(NN_curr+1);

% %% Optimized Code
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% sz_rr_vec_cand=size(rr_vec_cand);
% cand_pos_num=sz_rr_vec_cand(1);
% % Precalculation of the distance between candidate positions and particle positions
% dist_diff_DD=zeros(NN_curr.*cand_pos_num,DD);
% % dist_diff_DD_reshape=cell(1,DD);
% dist_diff_DD_reshape=zeros(DD*NN_curr,cand_pos_num);
% for ti_DD=1:1:DD
% %     temp_dist_diff_DD=combvec(transpose(rr_vec_cand(:,ti_DD)),transpose(rr_vec(:,ti_DD)));
%     temp_dist_diff_DD=combvec(transpose(rr_vec(1:1:NN_curr,ti_DD)),transpose(rr_vec_cand(:,ti_DD)));
%     dist_diff_DD(:,ti_DD)=temp_dist_diff_DD(1,:)-temp_dist_diff_DD(2,:);
% %     dist_diff_DD_reshape{ti_DD}=reshape(dist_diff_DD(:,ti_DD),[NN_curr,cand_pos_num]);
%     dist_diff_DD_reshape((ti_DD-1).*NN_curr+(1:1:NN_curr),:)=reshape(dist_diff_DD(:,ti_DD),[NN_curr,cand_pos_num]); % Row: [XX; XX; XX; ...; YY; YY; YY; ...] arrangement    
% end
% 
% curr_full_info=zeros(NN_curr,cand_pos_num);
% for ti_curr=1:1:NN_curr
%     curr_dist_info=zeros(DD,cand_pos_num);
%     for ti_DD=1:1:DD
%         curr_dist_info(ti_DD,:)=dist_diff_DD_reshape(((ti_DD-1).*NN_curr+ti_curr),:);
%     end
%     curr_full_info(ti_curr,:)=sum(cos(kk_range_set_target*curr_dist_info),1);    
% end
% rho_func=sum(curr_full_info,1);
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%% Finding the Optimum Point
%% Target Design: Hyperuniformity & Anti-Hyperuniformity
if HU_aHU==1
    %% Hyperuniformity
    [min_Y,min_ind]=min(rho_func);
else
    %% Anti-Hyperuniformity
    [min_Y,min_ind]=max(rho_func);
end
rr_vec(NN_curr+1,:)=rr_vec_cand(min_ind,:);
cost_func_monitor=min_Y;








