
function [cand_pos_num,rr_vec_cand,cand_kk_num,kk_range_set_target,theta_grid,theta_grid_k,theta_cand,theta_cand_k,rr_cand_del,rr_cand_del_kk,rr_cand_del_fit,rr_cand_del_kk_fit,f_rr_cand_del,f_kk_cand_del,rr_cand,rr_cand_kk,RR_ROI_max_arr,RR_ROI_min_arr,kk_ROI_max_arr,kk_ROI_min_arr]=monte_carlo_setting_arbitrary(monte_num_RR_max,monte_num_km_max,VV_ROI,VV_max,VV_ROI_kk,VV_max_kk,ang_rr_st,ang_rr_ed,ang_kk_st,ang_kk_ed,pdf_approx_discrete,DD,rr_vec_init,RR_ROI_min,RR_ROI_max,kk_ROI_min,kk_ROI_max)

%% Monte-Carlo Sampling: Real Space
cand_pos_num=round(monte_num_RR_max.*(VV_ROI./VV_max));   % Sampling Number for Spatial Domain
rr_vec_cand=zeros(cand_pos_num,2);

%% Angular Sampling
theta_grid=linspace(ang_rr_st,ang_rr_ed,cand_pos_num+1);
theta_cand=transpose(theta_grid(1:1:(length(theta_grid)-1)));

%% Radial Sampling: Probability Density Function for Radial Distribution
rr_cand_del=linspace(0,1,pdf_approx_discrete);

% F_rr_cand_del = rr_cand_del.^DD;    %% Cumulative Distribution Function
% f_rr_cand_del = DD*(rr_cand_del.^(DD-1));    %% Probability Distribution Function

%% 2D CDF & PDF
F_rr_cand_del = ((RR_ROI_max-RR_ROI_min)./(RR_ROI_max+RR_ROI_min)).*rr_cand_del.^2+2.*RR_ROI_min./(RR_ROI_max+RR_ROI_min).*rr_cand_del;    %% Cumulative Distribution Function
f_rr_cand_del = 2.*((RR_ROI_max-RR_ROI_min)./(RR_ROI_max+RR_ROI_min)).*rr_cand_del+2.*RR_ROI_min./(RR_ROI_max+RR_ROI_min);    %% Probability Distribution Function
F_rr_cand_del(1)=0;F_rr_cand_del(end)=1;

F_dist = makedist('PiecewiseLinear', 'x', rr_cand_del, 'Fx', F_rr_cand_del);    %% Approximation of Probability Distribution Function
rr_cand = transpose(random(F_dist, 1, cand_pos_num));   %% Random Generation

%% Arbitrary Parts
% perturb_rr_cand=zeros(length(theta_cand),1);
perturb_min=zeros(length(theta_cand),1);
perturb_max=zeros(length(theta_cand),1);
for ti_int=1:1:4
%     perturb_rr_cand=perturb_rr_cand+0.15.*rand(1).*cos(ti_int.*theta_cand+2.*pi.*rand(1));
    perturb_min=perturb_min+0.15.*rand(1).*cos(ti_int.*theta_cand+2.*pi.*rand(1));
    perturb_max=perturb_max+0.15.*rand(1).*cos(ti_int.*theta_cand+2.*pi.*rand(1));
end
% rr_cand=rr_cand.*(1+perturb_rr_cand);
RR_ROI_min_arr=RR_ROI_min.*(1-(perturb_min-min(perturb_min))./2);
RR_ROI_max_arr=RR_ROI_max.*(1+(perturb_max-min(perturb_max))./2);

% Position Random Sampling
rr_vec_cand(:,1)=rr_vec_init(:,1)+(RR_ROI_min_arr+rr_cand.*(RR_ROI_max_arr-RR_ROI_min_arr)).*cos(theta_cand);
rr_vec_cand(:,2)=rr_vec_init(:,2)+(RR_ROI_min_arr+rr_cand.*(RR_ROI_max_arr-RR_ROI_min_arr)).*sin(theta_cand);
rr_cand_del_fit=RR_ROI_min+rr_cand_del.*(RR_ROI_max-RR_ROI_min);
   

%% Monte-Carlo Sampling: Reciprocal Space
cand_kk_num=round(monte_num_km_max.*(VV_ROI_kk./VV_max_kk));   % Sampling Number for Reciprocal Domain
kk_range_set_target=zeros(cand_kk_num,2);

%% Angular Sampling
theta_grid_k=linspace(ang_kk_st,ang_kk_ed,cand_kk_num+1);
theta_cand_k=transpose(theta_grid_k(1:1:(length(theta_grid_k)-1)));

%% Radial Sampling: Probability Density Function for Radial Distribution
rr_cand_del_kk=linspace(0,1,pdf_approx_discrete);

% F_kk_cand_del = rr_cand_del_kk.^DD;    %% Cumulative Distribution Function 
% f_kk_cand_del = DD*(rr_cand_del_kk.^(DD-1));    %% Probability Distribution Function

%% 2D CDF & PDF
F_kk_cand_del = ((kk_ROI_max-kk_ROI_min)./(kk_ROI_max+kk_ROI_min)).*rr_cand_del_kk.^2+2.*kk_ROI_min./(kk_ROI_max+kk_ROI_min).*rr_cand_del_kk;    %% Cumulative Distribution Function
f_kk_cand_del = 2.*((kk_ROI_max-kk_ROI_min)./(kk_ROI_max+kk_ROI_min)).*rr_cand_del_kk+2.*kk_ROI_min./(kk_ROI_max+kk_ROI_min);    %% Probability Distribution Function
F_kk_cand_del(1)=0;F_kk_cand_del(end)=1;

F_dist_kk = makedist('PiecewiseLinear', 'x', rr_cand_del_kk, 'Fx', F_kk_cand_del);    %% Approximation of Probability Distribution Function
rr_cand_kk = transpose(random(F_dist_kk, 1, cand_kk_num));   %% Random Generation

%% Arbitrary Parts
% perturb_kk_cand=zeros(length(theta_cand_k),1);
perturb_min_kk=zeros(length(theta_cand_k),1);
perturb_max_kk=zeros(length(theta_cand_k),1);
for ti_int=2:2:8
%     perturb_kk_cand=perturb_kk_cand+0.15.*rand(1).*cos(ti_int.*theta_cand_k+2.*pi.*rand(1));
    perturb_min_kk=perturb_min_kk+0.15.*rand(1).*cos(ti_int.*theta_cand_k+2.*pi.*rand(1));
    perturb_max_kk=perturb_max_kk+0.15.*rand(1).*cos(ti_int.*theta_cand_k+2.*pi.*rand(1));
end
% rr_cand_kk=rr_cand_kk.*(1+perturb_kk_cand);
kk_ROI_min_arr=kk_ROI_min.*(1-(perturb_min_kk-min(perturb_min_kk))./2);
kk_ROI_max_arr=kk_ROI_max.*(1+(perturb_max_kk-min(perturb_max_kk))./2);

% Reciprocal Random Sampling
kk_range_set_target(:,1)=(kk_ROI_min_arr+rr_cand_kk.*(kk_ROI_max_arr-kk_ROI_min_arr)).*cos(theta_cand_k);
kk_range_set_target(:,2)=(kk_ROI_min_arr+rr_cand_kk.*(kk_ROI_max_arr-kk_ROI_min_arr)).*sin(theta_cand_k);
rr_cand_del_kk_fit=kk_ROI_min+rr_cand_del_kk.*(kk_ROI_max-kk_ROI_min);









































