

clear all;
load('../Data_Generation/Data/Pref_1_Type_01_HU_1_NN_00500_k_max_040_min_020_rng_001.mat');
mkdir('./Figures_Final/');
rr_vec_cand_min(:,1)=rr_vec_init(:,1)+RR_ROI_min_arr.*cos(theta_cand);
rr_vec_cand_min(:,2)=rr_vec_init(:,2)+RR_ROI_min_arr.*sin(theta_cand);
rr_vec_cand_max(:,1)=rr_vec_init(:,1)+RR_ROI_max_arr.*cos(theta_cand);
rr_vec_cand_max(:,2)=rr_vec_init(:,2)+RR_ROI_max_arr.*sin(theta_cand);
kk_range_set_min(:,1)=kk_ROI_min_arr.*cos(theta_cand_k);
kk_range_set_min(:,2)=kk_ROI_min_arr.*sin(theta_cand_k);
kk_range_set_max(:,1)=kk_ROI_max_arr.*cos(theta_cand_k);
kk_range_set_max(:,2)=kk_ROI_max_arr.*sin(theta_cand_k);

close all;
axis_linewidth=2.5;
tick_linewidth=2.5;

for ti_plot=1:1:2
    fig_temp=figure(ti_plot);hold on;
    axis_val=1.2;
    grid_size=0.03;
%     annotation('textarrow',x,y,'String',' Growth ','FontSize',13,'Linewidth',2)    
    p0 = [0 0];                         % First Point
    pp{1} = [axis_val 0];                         % Second Point
    pp{2} = [-axis_val 0];                         % Second Point
    pp{3} = [0 axis_val];                         % Second Point
    pp{4} = [0 -axis_val];                         % Second Point
    for ti_temp=1:1:4
        dp = pp{ti_temp}-p0;                         % Difference
        plot([-grid_size grid_size],[0.5 0.5],'color',[0 0 0],'linewidth',tick_linewidth);
        plot([-grid_size grid_size],[-0.5 -0.5],'color',[0 0 0],'linewidth',tick_linewidth);
        plot([0.5 0.5],[-grid_size grid_size],'color',[0 0 0],'linewidth',tick_linewidth);
        plot([-0.5 -0.5],[-grid_size grid_size],'color',[0 0 0],'linewidth',tick_linewidth);
        plot([-grid_size grid_size],[1.0 1.0],'color',[0 0 0],'linewidth',tick_linewidth);
        plot([-grid_size grid_size],[-1.0 -1.0],'color',[0 0 0],'linewidth',tick_linewidth);
        plot([1.0 1.0],[-grid_size grid_size],'color',[0 0 0],'linewidth',tick_linewidth);
        plot([-1.0 -1.0],[-grid_size grid_size],'color',[0 0 0],'linewidth',tick_linewidth);
        h_quiver=quiver(p0(1),p0(2),dp(1),dp(2),0,'color',[0 0 0],'linewidth',axis_linewidth);
    end
    h=gca;
    set(h,'Fontname','Helvetica','FontWeight','normal','FontSize',10,'PlotBoxAspectRatio',[1 1 1],'linewidth',1,'ydir','normal','xscale','linear');   
    axis([-1 1 -1 1].*1.2);
    axis off;
    movegui(fig_temp,'west');
    hold off;
end

%% Plotting MC Range: Position Space
fig_temp=figure(1);
hold on;
theta_plot=0:(2.*pi./1000):2.*pi;
clr_avg=[0.4 0.7 0.4];
plot(rr_vec_cand(:,1),rr_vec_cand(:,2),'marker','o','markerfacecolor',clr_avg,'markeredgecolor','none','markersize',2.5,'linestyle','none');
plot(rr_vec_cand_min(:,1),rr_vec_cand_min(:,2),'marker','none','markerfacecolor',clr_avg,'markeredgecolor','none','markersize',2.5,'linestyle','-','color',[0 0 0],'linewidth',1);
plot(rr_vec_cand_max(:,1),rr_vec_cand_max(:,2),'marker','none','markerfacecolor',clr_avg,'markeredgecolor','none','markersize',2.5,'linestyle','-','color',[0 0 0],'linewidth',1);

%% Plotting Particles
fig_temp=figure(2);
hold on;
theta_plot=0:(2.*pi./1000):2.*pi;
clr_avg=[1.0 0.0 0.0];
plot(rr_vec(:,1),rr_vec(:,2),'marker','o','markerfacecolor',clr_avg,'markeredgecolor','none','markersize',5.5,'linestyle','none');
plot(rr_vec_cand_min(:,1),rr_vec_cand_min(:,2),'marker','none','markerfacecolor',clr_avg,'markeredgecolor','none','markersize',2.5,'linestyle','-','color',[0 0 0],'linewidth',1);
plot(rr_vec_cand_max(:,1),rr_vec_cand_max(:,2),'marker','none','markerfacecolor',clr_avg,'markeredgecolor','none','markersize',2.5,'linestyle','-','color',[0 0 0],'linewidth',1);



for ti_plot=3:1:3
    fig_temp=figure(ti_plot); hold on;
    axis_val=0.9;
    grid_size=0.03;
%     annotation('textarrow',x,y,'String',' Growth ','FontSize',13,'Linewidth',2)    
    p0 = [0 0];                         % First Point
    pp{1} = [axis_val 0];                         % Second Point
    pp{2} = [-axis_val 0];                         % Second Point
    pp{3} = [0 axis_val];                         % Second Point
    pp{4} = [0 -axis_val];                         % Second Point
    for ti_temp=1:1:4
        dp = pp{ti_temp}-p0;                         % Difference
        plot([-grid_size grid_size],[0.5 0.5],'color',[0 0 0],'linewidth',tick_linewidth);
        plot([-grid_size grid_size],[-0.5 -0.5],'color',[0 0 0],'linewidth',tick_linewidth);
        plot([0.5 0.5],[-grid_size grid_size],'color',[0 0 0],'linewidth',tick_linewidth);
        plot([-0.5 -0.5],[-grid_size grid_size],'color',[0 0 0],'linewidth',tick_linewidth);
        h_quiver=quiver(p0(1),p0(2),dp(1),dp(2),0,'color',[0 0 0],'linewidth',axis_linewidth);
    end
    h=gca;
    set(h,'Fontname','Helvetica','FontWeight','normal','FontSize',10,'PlotBoxAspectRatio',[1 1 1],'linewidth',1,'ydir','normal','xscale','linear');   
    axis([-1 1 -1 1].*0.9);
    axis off;
    movegui(fig_temp,'west');
    hold off;
end


%% Plotting MC Range: Reciprocal Space
clr_reci=[0 0 0];
fig_temp=figure(3);
hold on;
theta_plot=0:(2.*pi./1000):2.*pi;
clr_avg=[0.1 0.1 0.6];
plot(kk_range_set_target(:,1)./kk_unit,kk_range_set_target(:,2)./kk_unit,'marker','o','markerfacecolor',clr_avg,'markeredgecolor','none','markersize',2.5,'linestyle','none');
plot(-kk_range_set_target(:,1)./kk_unit,-kk_range_set_target(:,2)./kk_unit,'marker','o','markerfacecolor',clr_avg,'markeredgecolor','none','markersize',2.5,'linestyle','none');
plot(kk_range_set_min(:,1)./kk_unit,kk_range_set_min(:,2)./kk_unit,'marker','none','markerfacecolor',clr_avg,'markeredgecolor','none','markersize',2.5,'linestyle','-','color',clr_reci,'linewidth',1);
plot(kk_range_set_max(:,1)./kk_unit,kk_range_set_max(:,2)./kk_unit,'marker','none','markerfacecolor',clr_avg,'markeredgecolor','none','markersize',2.5,'linestyle','-','color',clr_reci,'linewidth',1);
plot(-kk_range_set_min(:,1)./kk_unit,-kk_range_set_min(:,2)./kk_unit,'marker','none','markerfacecolor',clr_avg,'markeredgecolor','none','markersize',2.5,'linestyle','-','color',clr_reci,'linewidth',1);
plot(-kk_range_set_max(:,1)./kk_unit,-kk_range_set_max(:,2)./kk_unit,'marker','none','markerfacecolor',clr_avg,'markeredgecolor','none','markersize',2.5,'linestyle','-','color',clr_reci,'linewidth',1);
% axis off;

%% Plotting Structure Factor: Reciprocal Space
cmap_S_factor;
fig_temp=figure(4);
hold on;
theta_plot=0:(2.*pi./1000):2.*pi;
clr_avg=[0.1 0.1 0.5];
imagesc(kk_range_axis{1}./kk_unit,kk_range_axis{2}./kk_unit,SS_k_2D./NN);
% plot(kk_range_set_target(:,1)./kk_unit,kk_range_set_target(:,2)./kk_unit,'marker','o','markerfacecolor','none','markeredgecolor',[1 1 1],'markersize',2.5,'linestyle','none','linewidth',1);
% plot(-kk_range_set_target(:,1)./kk_unit,-kk_range_set_target(:,2)./kk_unit,'marker','o','markerfacecolor','none','markeredgecolor',[1 1 1],'markersize',2.5,'linestyle','none','linewidth',1);
plot(kk_range_set_min(:,1)./kk_unit,kk_range_set_min(:,2)./kk_unit,'marker','none','markerfacecolor',clr_avg,'markeredgecolor','none','markersize',2.5,'linestyle','-','color',[1 1 1],'linewidth',1);
plot(kk_range_set_max(:,1)./kk_unit,kk_range_set_max(:,2)./kk_unit,'marker','none','markerfacecolor',clr_avg,'markeredgecolor','none','markersize',2.5,'linestyle','-','color',[1 1 1],'linewidth',1);
plot(-kk_range_set_min(:,1)./kk_unit,-kk_range_set_min(:,2)./kk_unit,'marker','none','markerfacecolor',clr_avg,'markeredgecolor','none','markersize',2.5,'linestyle','-','color',[1 1 1],'linewidth',1);
plot(-kk_range_set_max(:,1)./kk_unit,-kk_range_set_max(:,2)./kk_unit,'marker','none','markerfacecolor',clr_avg,'markeredgecolor','none','markersize',2.5,'linestyle','-','color',[1 1 1],'linewidth',1);
colormap(cmap_gen);
caxis([0 max(SS_k./NN).*0.015]);


for ti_plot=4:1:4
    fig_temp=figure(ti_plot); hold on;
    axis_val=0.9;
    grid_size=0.03;
%     annotation('textarrow',x,y,'String',' Growth ','FontSize',13,'Linewidth',2)    
    p0 = [0 0];                         % First Point
    pp{1} = [axis_val 0];                         % Second Point
    pp{2} = [-axis_val 0];                         % Second Point
    pp{3} = [0 axis_val];                         % Second Point
    pp{4} = [0 -axis_val];                         % Second Point
    for ti_temp=1:1:4
        dp = pp{ti_temp}-p0;                         % Difference
        plot([-grid_size grid_size],[0.5 0.5],'color',[1 1 1],'linewidth',tick_linewidth);
        plot([-grid_size grid_size],[-0.5 -0.5],'color',[1 1 1],'linewidth',tick_linewidth);
        plot([0.5 0.5],[-grid_size grid_size],'color',[1 1 1],'linewidth',tick_linewidth);
        plot([-0.5 -0.5],[-grid_size grid_size],'color',[1 1 1],'linewidth',tick_linewidth);
        h_quiver=quiver(p0(1),p0(2),dp(1),dp(2),0,'color',[1 1 1],'linewidth',axis_linewidth);
    end
    h=gca;
    set(h,'Fontname','Helvetica','FontWeight','normal','FontSize',10,'PlotBoxAspectRatio',[1 1 1],'linewidth',1,'ydir','normal','xscale','linear');   
    axis([-1 1 -1 1].*0.9);
    axis off;
    movegui(fig_temp,'west');
    hold off;
end


figure(1);
set(gcf, 'InvertHardCopy', 'off');
set(gcf, 'Color', 'w');
saveas(gcf,'./Figures_Final/MC_rr','tif');
figure(2);
set(gcf, 'InvertHardCopy', 'off');
set(gcf, 'Color', 'w');
saveas(gcf,'./Figures_Final/particles','tif');
figure(3);
set(gcf, 'InvertHardCopy', 'off');
set(gcf, 'Color', [1 1 1]);
saveas(gcf,'./Figures_Final/MC_kk','tif');
figure(4);
set(gcf, 'InvertHardCopy', 'off');
set(gcf, 'Color', 'w');
saveas(gcf,'./Figures_Final/S_factor','tif');


%% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% 
% fig_temp=figure(); hold on;
% imagesc(kk_range_axis{1}./(2.*pi./RR_max),kk_range_axis{2}./(2.*pi./RR_max),SS_k_2D./NN);
% plot(kk_range_set_target(:,1)./(2.*pi./RR_max),kk_range_set_target(:,2)./(2.*pi./RR_max),'marker','o','markerfacecolor',[0 0 0],'markersize',3,'linestyle','none')
% 
% font_size=22;
% font_size_2=20;
% box on;
% caxis([0 max(SS_k./NN).*0.1]);
% axis([-kk_max kk_max -kk_max kk_max]./(2.*pi./RR_max));
% hx=xlabel('{\itk_x} (2\pi/{\itR})');
% hy=ylabel('{\itk_y} (2\pi/{\itR})');
% set(hx,'Fontname','Helvetica','FontWeight','normal','FontSize',font_size);
% set(hy,'Fontname','Helvetica','FontWeight','normal','FontSize',font_size);
% h=gca;
% set(h,'Fontname','Helvetica','FontWeight','normal','FontSize',font_size_2,'PlotBoxAspectRatio',[1 1 1],'linewidth',1,'ydir','normal','xscale','linear');   
% % saveas(gcf,'numerical_potential_5_2','tif');
% movegui(fig_temp,'west');
% 
% 
% 
% % fig_temp=figure(); hold on;
% % plot(1:1:NN,cost_func_monitor_arr);
% % movegui(fig_temp,'west');
% 
% 
% %% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 
% %% Color Parameters
% clr_level_val{1}=0.00;  clr_level{1}=[0.00 0.00 0.00];
% clr_level_val{2}=0.25;  clr_level{2}=[0.00 0.00 0.50];
% clr_level_val{3}=0.50;  clr_level{3}=[0.00 0.00 1.00];
% clr_level_val{4}=0.75;  clr_level{4}=[0.00 0.50 1.00];
% clr_level_val{5}=1.00;  clr_level{5}=[1.00 1.00 1.00];
% clr_min=clr_level_val{1};
% clr_max=clr_level_val{5};
% clr_map_grid=1000;
% [cmap_gen]=cmap_generator(clr_level,clr_level_val,clr_map_grid);
% 
% fig_temp=figure();hold on;
% imagesc(kk_range_axis{1}./kk_unit,kk_range_axis{2}./kk_unit,SS_k_2D./max(SS_k));
% % plot(kk_range_set_target(:,1),kk_range_set_target(:,2),'marker','o','markerfacecolor',[0 0 0],'markersize',3,'linestyle','none')
% 
% theta_plot=0:(2.*pi./1000):2.*pi;
% clr_bnd=[1 0 0];linewidth_bnd=2;
% plot(km_ROI_max.*cos(theta_plot),km_ROI_max.*sin(theta_plot),'color',clr_bnd,'linewidth',linewidth_bnd);
% plot(km_ROI_max.*cos(theta_plot),-km_ROI_max.*sin(theta_plot),'color',clr_bnd,'linewidth',linewidth_bnd);
% plot(km_ROI_min.*cos(theta_plot),km_ROI_min.*sin(theta_plot),'color',clr_bnd,'linewidth',linewidth_bnd);
% plot(km_ROI_min.*cos(theta_plot),-km_ROI_min.*sin(theta_plot),'color',clr_bnd,'linewidth',linewidth_bnd);
% colormap(cmap_gen);
% font_size=22;
% font_size_2=20;
% box on;
% caxis([0 max(SS_k./max(SS_k)).*0.02]);
% axis([-km_max km_max -km_max km_max]);
% % hx=xlabel('{\itk_x} (2\pi/{\itR})');
% % hy=ylabel('{\itk_y} (2\pi/{\itR})');
% hx=xlabel('{\itk_x}/{\itk}_m_a_x');
% hy=ylabel('{\itk_y}/{\itk}_m_a_x');
% set(hx,'Fontname','Helvetica','FontWeight','normal','FontSize',font_size);
% set(hy,'Fontname','Helvetica','FontWeight','normal','FontSize',font_size);
% h=gca;
% set(h,'Fontname','Helvetica','FontWeight','normal','FontSize',font_size_2,'PlotBoxAspectRatio',[1 1 1],'linewidth',1,'ydir','normal','xscale','linear');   
% movegui(fig_temp,'west');
% % saveas(gcf,'numerical_potential_5_2','tif');
% 
% fig_temp=figure();hold on;
% imagesc(kk_range_axis{1}./kk_unit,kk_range_axis{2}./kk_unit,kk_ROI_ind);
% % plot(kk_range_set_target(:,1),kk_range_set_target(:,2),'marker','o','markerfacecolor',[0 0 0],'markersize',3,'linestyle','none')
% 
% theta_plot=0:(2.*pi./1000):2.*pi;
% clr_bnd=[1 0 0];linewidth_bnd=2;
% plot(km_ROI_max.*cos(theta_plot),km_ROI_max.*sin(theta_plot),'color',clr_bnd,'linewidth',linewidth_bnd);
% plot(km_ROI_max.*cos(theta_plot),-km_ROI_max.*sin(theta_plot),'color',clr_bnd,'linewidth',linewidth_bnd);
% plot(km_ROI_min.*cos(theta_plot),km_ROI_min.*sin(theta_plot),'color',clr_bnd,'linewidth',linewidth_bnd);
% plot(km_ROI_min.*cos(theta_plot),-km_ROI_min.*sin(theta_plot),'color',clr_bnd,'linewidth',linewidth_bnd);
% colormap(cmap_gen);
% font_size=22;
% font_size_2=20;
% box on;
% caxis([0 max(SS_k./max(SS_k)).*0.02]);
% axis([-km_max km_max -km_max km_max]);
% % hx=xlabel('{\itk_x} (2\pi/{\itR})');
% % hy=ylabel('{\itk_y} (2\pi/{\itR})');
% hx=xlabel('{\itk_x}/{\itk}_m_a_x');
% hy=ylabel('{\itk_y}/{\itk}_m_a_x');
% set(hx,'Fontname','Helvetica','FontWeight','normal','FontSize',font_size);
% set(hy,'Fontname','Helvetica','FontWeight','normal','FontSize',font_size);
% h=gca;
% set(h,'Fontname','Helvetica','FontWeight','normal','FontSize',font_size_2,'PlotBoxAspectRatio',[1 1 1],'linewidth',1,'ydir','normal','xscale','linear');   
% movegui(fig_temp,'west');
% 
% 
% 
% fig_temp=figure();hold on;
% imagesc(kk_range_axis{1}./kk_unit,kk_range_axis{2}./kk_unit,kk_max_ind);
% % plot(kk_range_set_target(:,1),kk_range_set_target(:,2),'marker','o','markerfacecolor',[0 0 0],'markersize',3,'linestyle','none')
% 
% theta_plot=0:(2.*pi./1000):2.*pi;
% clr_bnd=[1 0 0];linewidth_bnd=2;
% plot(km_ROI_max.*cos(theta_plot),km_ROI_max.*sin(theta_plot),'color',clr_bnd,'linewidth',linewidth_bnd);
% plot(km_ROI_max.*cos(theta_plot),-km_ROI_max.*sin(theta_plot),'color',clr_bnd,'linewidth',linewidth_bnd);
% plot(km_ROI_min.*cos(theta_plot),km_ROI_min.*sin(theta_plot),'color',clr_bnd,'linewidth',linewidth_bnd);
% plot(km_ROI_min.*cos(theta_plot),-km_ROI_min.*sin(theta_plot),'color',clr_bnd,'linewidth',linewidth_bnd);
% colormap(cmap_gen);
% font_size=22;
% font_size_2=20;
% box on;
% caxis([0 max(SS_k./max(SS_k)).*0.02]);
% axis([-km_max km_max -km_max km_max]);
% % hx=xlabel('{\itk_x} (2\pi/{\itR})');
% % hy=ylabel('{\itk_y} (2\pi/{\itR})');
% hx=xlabel('{\itk_x}/{\itk}_m_a_x');
% hy=ylabel('{\itk_y}/{\itk}_m_a_x');
% set(hx,'Fontname','Helvetica','FontWeight','normal','FontSize',font_size);
% set(hy,'Fontname','Helvetica','FontWeight','normal','FontSize',font_size);
% h=gca;
% set(h,'Fontname','Helvetica','FontWeight','normal','FontSize',font_size_2,'PlotBoxAspectRatio',[1 1 1],'linewidth',1,'ydir','normal','xscale','linear');   
% movegui(fig_temp,'west');
% 
% 
% 
