
%%
clear all;
close all;

folder_name_fig='./Fig_Hist_Weight_Poisson_Crystals';
mkdir(folder_name_fig);

%% Pre-running Code: (1) PROC_degree_S_factor_Evol.m (2) PROC_HIST_Evol
plot_prefer_type=3;
NN_crystals=149;
% [1: SHU, 2: Poisson, 3: Crystal]

%%

NN=500;
km_ROI_max=0.5;
km_ROI_min=0.05;
NN_pre=1;
NN_post=0;

rng_arr_max=100;

font_size=24;
font_size_2=21;

bar_width=0.7;

degree_plot_min=-0.02;
degree_plot_max=0.02;
degree_prob_min=0;
degree_prob_max=0.11;

pos_clr_face=[0 0.5 0.9];
pos_clr_edge=pos_clr_face;
neg_clr_face=[0.9 0.5 0.0];
neg_clr_edge=neg_clr_face;

line_clr=[0.2 0.2 0.2];

axis_range=[-4 4 0 0.17];
axis_range_outer=[-4 4 0 0.17];
axis_range_inner=[-300 300 0 0.35];
axis_range_2=[0 1 0 0.08];
plot_axis_ratio_weight=[1.57 1 1];
plot_axis_ratio_SS=[1 1.6 1];

if plot_prefer_type==1    
    load_file_name=['./Hist_Data/Hist_Data_',num2str(1,'%03i'),'_NN_',num2str(NN,'%05i'),'_k_max_',num2str(round(1e2.*km_ROI_max),'%03i'),'_min_',num2str(round(1e2.*km_ROI_min),'%03i'),'_NN_pre_',num2str(NN_pre,'%05i'),'_NN_post_',num2str(NN_post,'%05i')]
    save_type_name='SHU'
elseif plot_prefer_type==2
    load_file_name=['./Hist_Data/Hist_Data_Poisson_NN_',num2str(NN,'%05i'),'_k_max_',num2str(round(1e2.*km_ROI_max),'%03i'),'_min_',num2str(round(1e2.*km_ROI_min),'%03i')]
    save_type_name='Poisson'
else
    load_file_name=['./Hist_Data/Hist_Data_Crystals_NN_',num2str(NN_crystals,'%05i'),'_k_max_',num2str(round(1e2.*km_ROI_max),'%03i'),'_min_',num2str(round(1e2.*km_ROI_min),'%03i')]
    NN=NN_crystals;
    save_type_name='Crystals'
    axis_range=[-4 4 0 0.35];
    axis_range_outer=[-4 4 0 0.55];
    if (NN_crystals==253)|(NN_crystals==377)|(NN_crystals==529)
        axis_range_outer=[-4 4 0 0.75];
    end
end

%% Background %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
x_st=(axis_range(1));
x_ed=(axis_range(2));
x_zero=0;
y_st=axis_range(3);
y_ed=axis_range(4);
z_c=0;
x_st_inner=(axis_range_inner(1));
x_ed_inner=(axis_range_inner(2));
x_zero_inner=0;
y_st_inner=axis_range_inner(3);
y_ed_inner=axis_range_inner(4);
z_c_inner=0;
x_st_outer=(axis_range_outer(1));
x_ed_outer=(axis_range_outer(2));
x_zero_outer=0;
y_st_outer=axis_range_outer(3);
y_ed_outer=axis_range_outer(4);
z_c_outer=0;
bar_face_clr=[1 1 1]*0.75;
bar_edge_clr=[1 1 1]*0.65;
clr_neg=[0.9 0.4 0.0]; 
clr_pos=[0.0 0.4 0.9]; 
clr_edge_back=[0 0 0];
alpha_rect=0.6;
line_width_rect=1; line_style_rect='none';

clr_level_val{1}=axis_range(1); clr_level{1}=clr_neg;
clr_level_val{2}=0;  clr_level{2}=[1 1 1];
clr_level_val{3}=-axis_range(1);  clr_level{3}=clr_pos;
clr_min=clr_level_val{1};
clr_max=clr_level_val{3};
clr_map_grid=1000;
[cmap_rect]=cmap_generator(clr_level,clr_level_val,clr_map_grid);
%% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

load(load_file_name);
NN_pre=1;
NN_post=0;

line_interp=1;

EVOL_num_arr=1:1:NN;
% folder_name=['./Post_Process/Figures_Degree_',num2str(plot_prefer_type,'%03i')];
% mkdir(folder_name)

for ti_EVOL=NN:100:NN

    if mod(ti_EVOL,50)==1
        ['EVOL Process = ',num2str((ti_EVOL-1)./(EVOL_num_arr_num-1)*100),'%']
    end

    EVOL_num=EVOL_num_arr(ti_EVOL);

    fig_temp2=figure(1); hold on;
%     fig_temp2=figure(1e4*plot_prefer_type+ti_EVOL); hold on;
    PROC_plot_rect_xy_NON_NORM_EVOL(x_st,x_ed,x_zero,y_st,y_ed,z_c,clr_edge_back,alpha_rect,line_width_rect,line_style_rect,cmap_rect)
    plot(0.*ones(20,1),linspace(axis_range(3),axis_range(4),20),'linestyle','--','color',[0 0 0],'linewidth',0.5);

    bar(hist_cent_degree_evol{ti_EVOL},degree_vec_hist_evol{ti_EVOL}./sum(degree_vec_hist_evol{ti_EVOL}),bar_width,'facecolor',bar_face_clr,'edgecolor',bar_edge_clr,'linestyle','-','linewidth',0.2);
    plot_object=plot(hist_cent_degree_evol_interp{ti_EVOL},degree_vec_hist_evol_interp{ti_EVOL}./sum(degree_vec_hist_evol{ti_EVOL}),'marker','none','linestyle','-','markersize',1,'markerfacecolor',[0 0 1],'markeredgecolor',[0 0 1],'linewidth',1.5,'color',[0 0.3 0]);
    plot_object.Color(4)=0.7;

    box on;
    axis(axis_range);
    hx=xlabel('{\itw_p}{\bf^K}');
    hy=ylabel('{\itP}({\itw_p}{\bf^K})');
    h=gca;
    set(h,'Fontname','Helvetica','FontWeight','normal','xtick',[-10:2:10],'ytick',[0.05:0.05:1],'FontSize',font_size_2,'PlotBoxAspectRatio',plot_axis_ratio_weight,'linewidth',1,'xscale','linear');
    set(hx,'Fontname','Helvetica','FontWeight','normal','FontSize',font_size);
    set(hy,'Fontname','Helvetica','FontWeight','normal','FontSize',font_size);
    movegui(fig_temp2,'west');

    %% Outer
    fig_temp2=figure(2); hold on;
%     fig_temp2=figure(1e8*plot_prefer_type+ti_EVOL); hold on;
    PROC_plot_rect_xy_NON_NORM_EVOL(x_st_outer,x_ed_outer,x_zero_outer,y_st_outer,y_ed_outer,z_c_outer,clr_edge_back,alpha_rect,line_width_rect,line_style_rect,cmap_rect)
    plot(0.*ones(20,1),linspace(axis_range_outer(3),axis_range_outer(4),20),'linestyle','--','color',[0 0 0],'linewidth',0.5);

    bar(hist_cent_degree_evol_outer{ti_EVOL},degree_vec_hist_evol_outer{ti_EVOL}./sum(degree_vec_hist_evol_outer{ti_EVOL}),bar_width,'facecolor',bar_face_clr,'edgecolor',bar_edge_clr,'linestyle','-','linewidth',0.2);
    plot_object=plot(hist_cent_degree_evol_outer_interp{ti_EVOL},degree_vec_hist_evol_outer_interp{ti_EVOL}./sum(degree_vec_hist_evol_outer{ti_EVOL}),'marker','none','linestyle','-','markersize',1,'markerfacecolor',[0 0 1],'markeredgecolor',[0 0 1],'linewidth',1.5,'color',[0 0.3 0]);
    plot_object.Color(4)=0.7;

    box on;
    axis(axis_range_outer);
    hx=xlabel('{\itw_p}{\bf^K}');
    hy=ylabel('{\itP}({\itw_p}{\bf^K})');
    h=gca;
    set(h,'Fontname','Helvetica','FontWeight','normal','xtick',[-10:2:10],'ytick',[0.05:0.05:1],'FontSize',font_size_2,'PlotBoxAspectRatio',plot_axis_ratio_weight,'linewidth',1,'xscale','linear');
    set(hx,'Fontname','Helvetica','FontWeight','normal','FontSize',font_size);
    set(hy,'Fontname','Helvetica','FontWeight','normal','FontSize',font_size);
    movegui(fig_temp2,'west');

%     %% Inner
%     fig_temp2=figure(4000+plot_prefer_type); hold on;
%     PROC_plot_rect_xy_NON_NORM_EVOL(x_st_inner,x_ed_inner,x_zero_inner,y_st_inner,y_ed_inner,z_c_inner,clr_edge_back,alpha_rect,line_width_rect,line_style_rect,cmap_rect)
%     plot(0.*ones(20,1),linspace(axis_range_inner(3),axis_range_inner(4),20),'linestyle','--','color',[0 0 0],'linewidth',0.5);
% 
%     bar(hist_cent_degree_evol_inner{ti_EVOL},degree_vec_hist_evol_inner{ti_EVOL}./sum(degree_vec_hist_evol_inner{ti_EVOL}),bar_width,'facecolor',[0 0.8 0],'edgecolor',[0 1 0],'linestyle','-','linewidth',0.2);
%     plot_object=plot(hist_cent_degree_evol_inner_interp{ti_EVOL},degree_vec_hist_evol_inner_interp{ti_EVOL}./sum(degree_vec_hist_evol_inner{ti_EVOL}),'marker','none','linestyle','-','markersize',1,'markerfacecolor',[0 0 1],'markeredgecolor',[0 0 1],'linewidth',1.5,'color',[0 0.3 0]);
%     plot_object.Color(4)=0.7;
% 
%     box on;
%     axis(axis_range_inner);
%     hx=xlabel('{\itw_p}{\bf^K}');
%     hy=ylabel('{\itP}({\itw_p}{\bf^K})');
%     set(hx,'Fontname','Helvetica','FontWeight','normal','FontSize',font_size);
%     set(hy,'Fontname','Helvetica','FontWeight','normal','FontSize',font_size);
%     h=gca;
%     set(h,'Fontname','Helvetica','FontWeight','normal','xtick',[-300:100:300],'FontSize',font_size_2,'PlotBoxAspectRatio',plot_axis_ratio,'linewidth',1,'xscale','linear');
%     movegui(fig_temp2,'west');

%     %% Save Figures %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%     figure(1000+plot_prefer_type);
%     set(gcf, 'InvertHardCopy', 'off');
%     set(gcf, 'Color', 'w');
%     saveas(gcf,[folder_name,'/Degree_Dist_Evol_',num2str(plot_prefer_type,'%03i'),'_EVOL_',num2str(EVOL_num)],'tif');
%     figure(2000+plot_prefer_type);
%     set(gcf, 'InvertHardCopy', 'off');
%     set(gcf, 'Color', 'w');
%     saveas(gcf,[folder_name,'/Degree_Dist_Evol_',num2str(plot_prefer_type,'%03i'),'_EVOL_',num2str(EVOL_num),'_training'],'tif');
%     figure(3000+plot_prefer_type);
%     set(gcf, 'InvertHardCopy', 'off');
%     set(gcf, 'Color', 'w');
%     saveas(gcf,[folder_name,'/Degree_Dist_Evol_',num2str(plot_prefer_type,'%03i'),'_EVOL_',num2str(EVOL_num),'_outer'],'tif');
% %     figure(4000+plot_prefer_type);
% %     set(gcf, 'InvertHardCopy', 'off');
% %     set(gcf, 'Color', 'w');
% %     saveas(gcf,[folder_name,'/Degree_Dist_Evol_',num2str(plot_prefer_type,'%03i'),'_EVOL_',num2str(EVOL_num),'_inner'],'tif');

%     close all;

    figure(1); 
    if plot_prefer_type==3
        plot_prefer_type_original=plot_prefer_type;
        NN=500;
        load_file_name_temp=['./Hist_Data/Hist_Data_',num2str(1,'%03i'),'_NN_',num2str(NN,'%05i'),'_k_max_',num2str(round(1e2.*km_ROI_max),'%03i'),'_min_',num2str(round(1e2.*km_ROI_min),'%03i'),'_NN_pre_',num2str(NN_pre,'%05i'),'_NN_post_',num2str(NN_post,'%05i')]
        load(load_file_name_temp);
%         if ti_EVOL<=NN
%             plot_object=plot(hist_cent_degree_evol_interp{ti_EVOL},degree_vec_hist_evol_interp{ti_EVOL}./sum(degree_vec_hist_evol{ti_EVOL}),'marker','none','linestyle','--','markersize',1,'markerfacecolor',[0 0 1],'markeredgecolor',[0 0 1],'linewidth',2,'color',[1 0 0]);
%         else
            plot_object=plot(hist_cent_degree_evol_interp{NN},degree_vec_hist_evol_interp{NN}./sum(degree_vec_hist_evol{NN}),'marker','none','linestyle','--','markersize',1,'markerfacecolor',[0 0 1],'markeredgecolor',[0 0 1],'linewidth',2,'color',[1 0 0]);            
%         end
        plot_prefer_type=plot_prefer_type_original;
        load(load_file_name);
        if plot_prefer_type==3
            NN=NN_crystals;
        end
        NN_pre=1;
        NN_post=0;
    end

    file_name_1=[folder_name_fig,'/Fig_degree_K_L_',save_type_name,'_NN_',num2str(NN,'%03i'),'.tif']
    save_fig = gcf;
    set(save_fig, 'Position',  [100, 30, 800, 900]);
    exportgraphics(save_fig,file_name_1,'Resolution',500);

    figure(2); 
    if plot_prefer_type==3
        plot_prefer_type_original=plot_prefer_type;
        NN=500;
        load_file_name_temp=['./Hist_Data/Hist_Data_',num2str(1,'%03i'),'_NN_',num2str(NN,'%05i'),'_k_max_',num2str(round(1e2.*km_ROI_max),'%03i'),'_min_',num2str(round(1e2.*km_ROI_min),'%03i'),'_NN_pre_',num2str(NN_pre,'%05i'),'_NN_post_',num2str(NN_post,'%05i')]
        load(load_file_name_temp);
%         if ti_EVOL<=NN
%             plot_object=plot(hist_cent_degree_evol_outer_interp{ti_EVOL},degree_vec_hist_evol_outer_interp{ti_EVOL}./sum(degree_vec_hist_evol_outer{ti_EVOL}),'marker','none','linestyle','--','markersize',1,'markerfacecolor',[0 0 1],'markeredgecolor',[0 0 1],'linewidth',2,'color',[1 0 0]);
%         else
            plot_object=plot(hist_cent_degree_evol_outer_interp{NN},degree_vec_hist_evol_outer_interp{NN}./sum(degree_vec_hist_evol_outer{NN}),'marker','none','linestyle','--','markersize',1,'markerfacecolor',[0 0 1],'markeredgecolor',[0 0 1],'linewidth',2,'color',[1 0 0]);            
%         end
        plot_prefer_type=plot_prefer_type_original;
        load(load_file_name);
        if plot_prefer_type==3
            NN=NN_crystals;
        end
        NN_pre=1;
        NN_post=0;
    end
    file_name_2=[folder_name_fig,'/Fig_degree_K_S_',save_type_name,'_NN_',num2str(NN,'%03i'),'.tif']
    save_fig = gcf;
    set(save_fig, 'Position',  [100, 30, 800, 900]);
    exportgraphics(save_fig,file_name_2,'Resolution',500);
    

end
      
err_ind=1:50:NN;
SS_clr=[0.3 0.6 1.0];
SS_clr_outer=[0.6 0.8 0.2];
SS_clr_line=[0.0 0 0.7];
SS_clr_line_outer=[0.0 0.6 0.0];
scatter_size=15;
scatter_alpha=0.01;
axis_SS_k=[0 NN 0 1.65];
% fig_temp2=figure(10000+plot_prefer_type); hold on;
fig_temp2=figure(4); hold on;
for ti_rng=1:1:rng_arr_max
    fig_scatter=scatter(1:1:NN,SS_k_evol_arr(ti_rng,:),scatter_size,SS_clr,'filled');
    fig_scatter.MarkerFaceAlpha = scatter_alpha;
    fig_scatter=scatter(1:1:NN,SS_k_evol_outer_arr(ti_rng,:),scatter_size,SS_clr_outer,'filled');
    fig_scatter.MarkerFaceAlpha = scatter_alpha;
end
plot(1:1:NN,mean(SS_k_evol_arr,1),'linewidth',3,'color',SS_clr);
if plot_prefer_type~=3
    errorbar(err_ind,mean(SS_k_evol_arr(:,err_ind),1),std(SS_k_evol_arr(:,err_ind),1),'linewidth',2,'color',SS_clr_line,'linestyle','none');
    plot(err_ind,mean(SS_k_evol_arr(:,err_ind),1),'linewidth',0.5,'color',SS_clr,'linestyle','none','marker','o','markerfacecolor','none','markeredgecolor',SS_clr_line,'linewidth',1.5);
end
plot(1:1:NN,mean(SS_k_evol_outer_arr,1),'linewidth',3,'color',SS_clr_outer);
if plot_prefer_type~=3
    errorbar(err_ind,mean(SS_k_evol_outer_arr(:,err_ind),1),std(SS_k_evol_outer_arr(:,err_ind),1),'linewidth',2,'color',SS_clr_line_outer,'linestyle','none');
    plot(err_ind,mean(SS_k_evol_outer_arr(:,err_ind),1),'linewidth',0.5,'color',SS_clr_outer,'linestyle','none','marker','o','markerfacecolor','none','markeredgecolor',SS_clr_line_outer,'linewidth',1.5);
end

box on;
axis(axis_SS_k);
hx=xlabel('Evolution {\itn}');
% hy=ylabel('<{\itS_n}>{\bf_K}, <{\itS_n}>{\bf_K}^c');
hy=ylabel('<{\itS_n}>{\bf_K}');
h=gca;
set(h,'Fontname','Helvetica','FontWeight','normal','xtick',[0:100:NN],'FontSize',font_size_2-2,'PlotBoxAspectRatio',plot_axis_ratio_SS,'linewidth',1,'xscale','linear');
set(hx,'Fontname','Helvetica','FontWeight','normal','FontSize',font_size-2);
set(hy,'Fontname','Helvetica','FontWeight','normal','FontSize',font_size-2);
movegui(fig_temp2,'west');

if plot_prefer_type==3
    NN=500;
    load_file_name_temp=['./Hist_Data/Hist_Data_',num2str(1,'%03i'),'_NN_',num2str(NN,'%05i'),'_k_max_',num2str(round(1e2.*km_ROI_max),'%03i'),'_min_',num2str(round(1e2.*km_ROI_min),'%03i'),'_NN_pre_',num2str(NN_pre,'%05i'),'_NN_post_',num2str(NN_post,'%05i')]
    load(load_file_name_temp);
    plot(1:1:NN,mean(SS_k_evol_arr,1),'linewidth',2.5,'color',SS_clr,'linestyle','--');
    plot(1:1:NN,mean(SS_k_evol_outer_arr,1),'linewidth',2.5,'color',SS_clr_outer,'linestyle','--');
    load(load_file_name);
    if plot_prefer_type==3
        NN=NN_crystals;
    end
    NN_pre=1;
    NN_post=0;
end

figure(4);
file_name_4=[folder_name_fig,'/Fig_S_Evol_',save_type_name,'_NN_',num2str(NN,'%03i'),'.tif']
save_fig = gcf;
set(save_fig, 'Position',  [100, 30, 800, 900]);
exportgraphics(save_fig,file_name_4,'Resolution',500);


















        