
clear all;
close all;

folder_name_fig='./Fig_particle_prob';
mkdir(folder_name_fig);

%% Pre-running Code: (1) PROC_degree_S_factor_Evol.m (2) PROC_HIST_Evol
problem_type=1; % [1: SHU, 2: Poisson, 3: Crystals]
if problem_type==1    
    NN_pre_1=1;
    NN_post_1=0;    
    problem_case_text='001';    
elseif problem_type==2
    problem_case_text='Poisson';
else
    NN_crystals=149;
    problem_case_text='Crystal';  
end
%% Basic Plot Setting
scatter_alpha=0.8;
clr_level_val{1}=-1.0; clr_level{1}=[0.9 0.5 0.0];
clr_level_val{2}=-0.5;  clr_level{2}=[0.95 0.25 0.50];
clr_level_val{3}=0.0;  clr_level{3}=[1.00 1.00 1.00];
clr_level_val{4}=0.5;  clr_level{4}=[0.50 0.75 0.95];
clr_level_val{5}=1.0;  clr_level{5}=[0 0.5 0.9];
clr_min=clr_level_val{1};
clr_max=clr_level_val{5};
clr_map_grid=1000;
[cmap_gen_prob]=cmap_generator(clr_level,clr_level_val,clr_map_grid);
plot_norm_degree_offset=1e-2;
scatter_sz_fac=110;
scatter_caxis=[-0.3 0.3];
font_size=22;
font_size_2=20;
clr_line=[0 1 1];
line_style=':';

%% Loading Data Info.
if problem_type==1
    NN=500;
    km_ROI_max=0.5;
    km_ROI_min=0.05;
    NN_pre=NN_pre_1;
    NN_post=NN_post_1;    
    rng_arr_max=100;    
elseif problem_type==2
    NN=500;
    km_ROI_max=0.5;
    km_ROI_min=0.05;
    NN_pre=1;
    NN_post=0;    
    rng_arr_max=100;      
else
    NN=NN_crystals;
    km_ROI_max=0.5;
    km_ROI_min=0.05;
    NN_pre=1;
    NN_post=0;    
    rng_arr_max=1;   
end

%% Loading Particle Information
if problem_type==1
    load_file_name=['./Post_Proc_data/Post_Data_',problem_case_text,'_NN_',num2str(NN,'%05i'),'_k_max_',num2str(round(1e2.*km_ROI_max),'%03i'),'_min_',num2str(round(1e2.*km_ROI_min),'%03i'),'_NN_pre_',num2str(NN_pre,'%05i'),'_NN_post_',num2str(NN_post,'%05i')]
elseif problem_type==2
    load_file_name=['./Post_Proc_data/Post_Data_',problem_case_text,'_NN_',num2str(NN,'%05i'),'_k_max_',num2str(round(1e2.*km_ROI_max),'%03i'),'_min_',num2str(round(1e2.*km_ROI_min),'%03i')]    
else
    load_file_name=['./Post_Proc_data/Post_Data_',problem_case_text,'_NN_',num2str(NN,'%05i'),'_k_max_',num2str(round(1e2.*km_ROI_max),'%03i'),'_min_',num2str(round(1e2.*km_ROI_min),'%03i')]        
end
load(load_file_name);

% %% Loading Degree Information
% load_file_name=['./Hist_Data/Hist_Data_',num2str(prefer_type,'%03i'),'_NN_',num2str(NN,'%05i'),'_k_max_',num2str(round(1e2.*km_ROI_max),'%03i'),'_min_',num2str(round(1e2.*km_ROI_min),'%03i'),'_NN_pre_',num2str(NN_pre,'%05i'),'_NN_post_',num2str(NN_post,'%05i')]
% load(load_file_name);

%% Plotting  
if problem_type==3
    ti_rng_max=1;
else
    ti_rng_max=5;
end
for ti_EVOL=NN:1:NN
    for ti_rng=1:1:ti_rng_max
        
       %% Figure 01: Degree-dependent Particles
        plot_num_1=1000*prefer_type+ti_EVOL;
        if problem_type==1
            save_file_name_1=[folder_name_fig,'/Evol_Degree_Particles_',problem_case_text,'_NN_',num2str(NN,'%03i'),'_EVOL_',num2str(ti_EVOL,'%05i'),'_NN_pre_',num2str(NN_pre,'%05i'),'_NN_post_',num2str(NN_post,'%05i'),'_rng_',num2str(ti_rng,'%03i'),'.tif']            
        else
            save_file_name_1=[folder_name_fig,'/Evol_Degree_Particles_',problem_case_text,'_NN_',num2str(NN,'%03i'),'_EVOL_',num2str(ti_EVOL,'%05i'),'_rng_',num2str(ti_rng,'%03i'),'.tif']
        end
        %% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        fig_temp=figure(plot_num_1);
        hold on;
        theta_plot=0:(2.*pi./1000):2.*pi;
        rr_plot=1;
        plot(rr_plot.*cos(theta_plot),rr_plot.*sin(theta_plot),'k-');
        plot(rr_plot.*cos(theta_plot),-rr_plot.*sin(theta_plot),'k-');        
        
        % clr_plot_prob_arr;
        plot_degree=weight_degree_SS_k_arr{ti_EVOL}(((ti_rng-1).*ti_EVOL+1):1:(ti_rng.*ti_EVOL),1);
        plot_abs_degree=abs(plot_degree);
        plot_degree_sign=sign(plot_degree);
        if problem_type==1   %% In this case, ti_EVOL==N
            
%             if problem_1_case==1
%                 plot(RR_ROI_min.*cos(theta_plot),RR_ROI_min.*sin(theta_plot),'k-');
%                 plot(RR_ROI_min.*cos(theta_plot),-RR_ROI_min.*sin(theta_plot),'k-');
%             elseif problem_1_case==2
%                 plot(RR_ROI_max.*cos(theta_plot),RR_ROI_max.*sin(theta_plot),'k-');
%                 plot(RR_ROI_max.*cos(theta_plot),-RR_ROI_max.*sin(theta_plot),'k-');
%             else
%                 plot(RR_ROI_min.*cos(theta_plot),RR_ROI_min.*sin(theta_plot),'k-');
%                 plot(RR_ROI_min.*cos(theta_plot),-RR_ROI_min.*sin(theta_plot),'k-');
%             end
            
            if NN_post==0   %% Poisson & SHU shielding
              %% (1)-(NN_pre): Poisson Particles
                plot_particle_ind=((ti_rng-1).*ti_EVOL+1):1:(((ti_rng-1).*ti_EVOL+1)+NN_pre);
                plot_particle_ind_degree=plot_particle_ind-(ti_rng-1).*ti_EVOL;
                scatter_plot=scatter(rr_vec_arr(plot_particle_ind,1),rr_vec_arr(plot_particle_ind,2),scatter_sz_fac*plot_abs_degree(plot_particle_ind_degree),plot_degree_sign(plot_particle_ind_degree),'filled','o','markeredgecolor',[0 0 0],'linewidth',0.5);
                scatter_plot.MarkerFaceAlpha = scatter_alpha;
                colormap(cmap_gen_prob);
                caxis([scatter_caxis]);
              %% (NN_pre+1)-(NN): SHU Particles
                plot_particle_ind=((ti_rng-1).*ti_EVOL+NN_pre+1):1:(ti_rng.*ti_EVOL);
                plot_particle_ind_degree=plot_particle_ind-(ti_rng-1).*ti_EVOL;
                scatter_plot=scatter(rr_vec_arr(plot_particle_ind,1),rr_vec_arr(plot_particle_ind,2),scatter_sz_fac*plot_abs_degree(plot_particle_ind_degree),plot_degree_sign(plot_particle_ind_degree),'filled','o','markeredgecolor',[0 0 0],'linewidth',0.5);
                scatter_plot.MarkerFaceAlpha = scatter_alpha;
                colormap(cmap_gen_prob);
                caxis([scatter_caxis]);
            else    %% SHU + Poisson
              %% (1)-(NN_pre): Poisson Particles
                plot_particle_ind=((ti_rng-1).*ti_EVOL+1):1:(((ti_rng-1).*ti_EVOL+1)+(NN-NN_post));
                plot_particle_ind_degree=plot_particle_ind-(ti_rng-1).*ti_EVOL;
                scatter_plot=scatter(rr_vec_arr(plot_particle_ind,1),rr_vec_arr(plot_particle_ind,2),scatter_sz_fac*plot_abs_degree(plot_particle_ind_degree),plot_degree_sign(plot_particle_ind_degree),'filled','o','markeredgecolor',[0 0 0],'linewidth',0.5);
                scatter_plot.MarkerFaceAlpha = scatter_alpha;
                colormap(cmap_gen_prob);
                caxis([scatter_caxis]);
              %% (NN_pre+1)-(NN): SHU Particles
                plot_particle_ind=((ti_rng-1).*ti_EVOL+(NN-NN_post)+1):1:(ti_rng.*ti_EVOL);
                plot_particle_ind_degree=plot_particle_ind-(ti_rng-1).*ti_EVOL;
                scatter_plot=scatter(rr_vec_arr(plot_particle_ind,1),rr_vec_arr(plot_particle_ind,2),scatter_sz_fac*plot_abs_degree(plot_particle_ind_degree),plot_degree_sign(plot_particle_ind_degree),'filled','^','markeredgecolor',[0 0 0],'linewidth',0.5);
                scatter_plot.MarkerFaceAlpha = scatter_alpha;
                colormap(cmap_gen_prob);
                caxis([scatter_caxis]);
            end    
            
        elseif problem_type==2   
            plot(RR_ROI_min.*cos(theta_plot),RR_ROI_min.*sin(theta_plot),'k-');
            plot(RR_ROI_min.*cos(theta_plot),-RR_ROI_min.*sin(theta_plot),'k-');
            scatter_plot=scatter(rr_vec_arr(((ti_rng-1).*ti_EVOL+1):1:(ti_rng.*ti_EVOL),1),rr_vec_arr(((ti_rng-1).*ti_EVOL+1):1:(ti_rng.*ti_EVOL),2),scatter_sz_fac*plot_abs_degree,plot_degree_sign,'filled','^','markeredgecolor',[0 0 0],'linewidth',0.5);
            scatter_plot.MarkerFaceAlpha = scatter_alpha;
            colormap(cmap_gen_prob);
            caxis([-1 1]);
        else            
            plot(RR_ROI_min.*cos(theta_plot),RR_ROI_min.*sin(theta_plot),'k-');
            plot(RR_ROI_min.*cos(theta_plot),-RR_ROI_min.*sin(theta_plot),'k-');
            scatter_plot=scatter(rr_vec_arr(((ti_rng-1).*ti_EVOL+1):1:(ti_rng.*ti_EVOL),1),rr_vec_arr(((ti_rng-1).*ti_EVOL+1):1:(ti_rng.*ti_EVOL),2),scatter_sz_fac*plot_abs_degree,plot_degree_sign,'filled','s','markeredgecolor',[0 0 0],'linewidth',0.5);
            scatter_plot.MarkerFaceAlpha = scatter_alpha;
            colormap(cmap_gen_prob);
            caxis([-1 1]);
        end
        
        h=gca;
        set(h,'PlotBoxAspectRatio',[1 1 1],'linewidth',1);
        axis off;
        % plot3(rr_vec(1:1:NN_curr,1),rr_vec(1:1:NN_curr,2),1.*ones(NN_curr,1),'marker','none','markerfacecolor',clr_plot,'markeredgecolor',[0 0.5 0],'markersize',10,'linestyle','--');
        movegui(fig_temp,'west');
        
        figure(plot_num_1);
        save_fig = gcf;
        set(save_fig, 'InvertHardCopy', 'off');
        set(save_fig, 'Color', 'w');
        set(save_fig, 'Position',  [100, 100, 1200, 900]);
            exportgraphics(save_fig,save_file_name_1,'Resolution',500);
        % % %     saveas(gcf,save_file_name_1,'tif');

        %% Figure 02: Particle Distribution
        plot_num_2=10000*prefer_type+ti_EVOL;
        if problem_type==1
            save_file_name_2=[folder_name_fig,'/Evol_Particles_',problem_case_text,'_NN_',num2str(NN,'%03i'),'_EVOL_',num2str(ti_EVOL,'%05i'),'_NN_pre_',num2str(NN_pre,'%05i'),'_NN_post_',num2str(NN_post,'%05i'),'_rng_',num2str(ti_rng,'%03i'),'.tif']            
        else
            save_file_name_2=[folder_name_fig,'/Evol_Particles_',problem_case_text,'_NN_',num2str(NN,'%03i'),'_EVOL_',num2str(ti_EVOL,'%05i'),'_rng_',num2str(ti_rng,'%03i'),'.tif']
        end
        %% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        fig_temp=figure(plot_num_2);
        hold on;
        theta_plot=0:(2.*pi./1000):2.*pi;
        rr_plot=1;
        plot(rr_plot.*cos(theta_plot),rr_plot.*sin(theta_plot),'k-');
        plot(rr_plot.*cos(theta_plot),-rr_plot.*sin(theta_plot),'k-');
        plot(RR_ROI_min.*cos(theta_plot),RR_ROI_min.*sin(theta_plot),'k-');
        plot(RR_ROI_min.*cos(theta_plot),-RR_ROI_min.*sin(theta_plot),'k-');
        
        clr_poisson=[0.2 0.7 0.2];
        clr_SHU=[0.2 0.2 0.2];
        
        clr_plot=clr_SHU;
        
        if problem_type==1   %% In this case, ti_EVOL==N       
            
%             if problem_1_case==1
%                 plot(RR_ROI_min.*cos(theta_plot),RR_ROI_min.*sin(theta_plot),'k-');
%                 plot(RR_ROI_min.*cos(theta_plot),-RR_ROI_min.*sin(theta_plot),'k-');
%             elseif problem_1_case==2
%                 plot(RR_ROI_max.*cos(theta_plot),RR_ROI_max.*sin(theta_plot),'k-');
%                 plot(RR_ROI_max.*cos(theta_plot),-RR_ROI_max.*sin(theta_plot),'k-');
%             else
%                 plot(RR_ROI_min.*cos(theta_plot),RR_ROI_min.*sin(theta_plot),'k-');
%                 plot(RR_ROI_min.*cos(theta_plot),-RR_ROI_min.*sin(theta_plot),'k-');
%             end
            
            if NN_post==0   %% Poisson & SHU shielding
                %% (1)-(NN_pre): Poisson Particles
                plot_particle_ind=((ti_rng-1).*ti_EVOL+1):1:(((ti_rng-1).*ti_EVOL+1)+NN_pre);
                plot3(rr_vec_arr(plot_particle_ind,1),rr_vec_arr(plot_particle_ind,2),1.*ones(length(plot_particle_ind),1),'marker','^','markerfacecolor',clr_plot,'markeredgecolor',clr_plot,'markersize',8,'linestyle','none');
                %% (NN_pre+1)-(NN): SHU Particles
                plot_particle_ind=((ti_rng-1).*ti_EVOL+NN_pre+1):1:(ti_rng.*ti_EVOL);
                plot3(rr_vec_arr(plot_particle_ind,1),rr_vec_arr(plot_particle_ind,2),1.*ones(length(plot_particle_ind),1),'marker','o','markerfacecolor',clr_plot,'markeredgecolor',clr_plot,'markersize',8,'linestyle','none');
            else    %% SHU + Poisson
                %% (1)-(NN_pre): Poisson Particles
                plot_particle_ind=((ti_rng-1).*ti_EVOL+1):1:(((ti_rng-1).*ti_EVOL+1)+(NN-NN_post));
                plot3(rr_vec_arr(plot_particle_ind,1),rr_vec_arr(plot_particle_ind,2),1.*ones(length(plot_particle_ind),1),'marker','o','markerfacecolor',clr_plot,'markeredgecolor',clr_plot,'markersize',8,'linestyle','none');
                caxis([-1 1]);
                %% (NN_pre+1)-(NN): SHU Particles
                plot_particle_ind=((ti_rng-1).*ti_EVOL+(NN-NN_post)+1):1:(ti_rng.*ti_EVOL);
                plot3(rr_vec_arr(plot_particle_ind,1),rr_vec_arr(plot_particle_ind,2),1.*ones(length(plot_particle_ind),1),'marker','^','markerfacecolor',clr_plot,'markeredgecolor',clr_plot,'markersize',8,'linestyle','none');
            end
        elseif problem_type==2
            plot(RR_ROI_min.*cos(theta_plot),RR_ROI_min.*sin(theta_plot),'k-');
            plot(RR_ROI_min.*cos(theta_plot),-RR_ROI_min.*sin(theta_plot),'k-');
            plot3(rr_vec_arr(((ti_rng-1).*ti_EVOL+1):1:(ti_rng.*ti_EVOL),1),rr_vec_arr(((ti_rng-1).*ti_EVOL+1):1:(ti_rng.*ti_EVOL),2),1.*ones(ti_EVOL,1),'marker','^','markerfacecolor',clr_plot,'markeredgecolor',clr_plot,'markersize',10,'linestyle','none');
        else
            plot(RR_ROI_min.*cos(theta_plot),RR_ROI_min.*sin(theta_plot),'k-');
            plot(RR_ROI_min.*cos(theta_plot),-RR_ROI_min.*sin(theta_plot),'k-');
            plot3(rr_vec_arr(((ti_rng-1).*ti_EVOL+1):1:(ti_rng.*ti_EVOL),1),rr_vec_arr(((ti_rng-1).*ti_EVOL+1):1:(ti_rng.*ti_EVOL),2),1.*ones(ti_EVOL,1),'marker','s','markerfacecolor',clr_plot,'markeredgecolor',clr_plot,'markersize',10,'linestyle','none');
        end
        
        h=gca;
        set(h,'PlotBoxAspectRatio',[1 1 1],'linewidth',1);
        axis off;
        % plot3(rr_vec(1:1:NN_curr,1),rr_vec(1:1:NN_curr,2),1.*ones(NN_curr,1),'marker','none','markerfacecolor',clr_plot,'markeredgecolor',[0 0.5 0],'markersize',10,'linestyle','--');
        movegui(fig_temp,'west');
        
        figure(plot_num_2);
        save_fig = gcf;
        set(save_fig, 'InvertHardCopy', 'off');
        set(save_fig, 'Color', 'w');
        set(save_fig, 'Position',  [100, 100, 1200, 900]);
            exportgraphics(save_fig,save_file_name_2,'Resolution',500);
        % % %     saveas(gcf,save_file_name_2,'tif');
        
        
        %% Figure 03: S-Factor
        %% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        %% Structural Factor Calculation
        kk_del_fac=0.1;
        [SS_k,kk_range_set,kk_range_axis,kk_del,kk_axis_num,kk_comb_num]=structure_factor_specific(rr_vec_arr(((ti_rng-1).*ti_EVOL+1):1:(ti_rng.*ti_EVOL),:),kk_max,RR_max,kk_del_fac);
        ['S-Factor END!']
        
        %% Structure Factor 2D Conversion
        SS_k_2D=reshape(SS_k,kk_axis_num(1),kk_axis_num(2));
        [kk_range_axis_grid{1},kk_range_axis_grid{2}]=meshgrid(kk_range_axis{1},kk_range_axis{2});
        
        %% Structure Factor ROI Analysis
        kk_range_rr_grid=sqrt(kk_range_axis_grid{1}.^2+kk_range_axis_grid{2}.^2);
        kk_ROI_ind=(kk_range_rr_grid>=kk_ROI_min)&(kk_range_rr_grid<=kk_ROI_max); kk_ROI_ind_1D=kk_ROI_ind(:);
        kk_non_ROI_inner_ind=(kk_range_rr_grid<kk_ROI_min); kk_non_ROI_inner_ind_1D=kk_non_ROI_inner_ind(:);
        kk_non_ROI_outer_ind=(kk_range_rr_grid>kk_ROI_max)&(kk_range_rr_grid<=kk_max); kk_non_ROI_outer_ind_1D=kk_non_ROI_outer_ind(:);
        kk_non_ROI=kk_non_ROI_inner_ind+kk_non_ROI_outer_ind; kk_non_ROI_1D=kk_non_ROI(:);
        kk_max_ind=(kk_range_rr_grid<=kk_max); kk_max_ind_1D=kk_max_ind(:);
        %% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        
        plot_num_3=100000*prefer_type+ti_EVOL;
        if problem_type==1
            save_file_name_3=[folder_name_fig,'/S_Factor_',problem_case_text,'_NN_',num2str(NN,'%03i'),'_EVOL_',num2str(ti_EVOL,'%05i'),'_NN_pre_',num2str(NN_pre,'%05i'),'_NN_post_',num2str(NN_post,'%05i'),'_rng_',num2str(ti_rng,'%03i'),'.tif']            
        else
            save_file_name_3=[folder_name_fig,'/S_Factor_',problem_case_text,'_NN_',num2str(NN,'%03i'),'_EVOL_',num2str(ti_EVOL,'%05i'),'_rng_',num2str(ti_rng,'%03i'),'.tif']
        end
        %% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        fig_temp=figure(plot_num_3);
        cmap_S_factor;
        kk_range_set_min(:,1)=kk_ROI_min.*cos(theta_cand_k);
        kk_range_set_min(:,2)=kk_ROI_min.*sin(theta_cand_k);
        kk_range_set_max(:,1)=kk_ROI_max.*cos(theta_cand_k);
        kk_range_set_max(:,2)=kk_ROI_max.*sin(theta_cand_k);
        hold on;
        clr_avg=[0.4 0.4 0.7];
        imagesc(kk_range_axis{1}./kk_unit,kk_range_axis{2}./kk_unit,SS_k_2D./NN);
        % plot(kk_range_set_target(:,1)./kk_unit,kk_range_set_target(:,2)./kk_unit,'marker','o','markerfacecolor','none','markeredgecolor',[1 1 1],'markersize',2.5,'linestyle','none','linewidth',1);
        % plot(-kk_range_set_target(:,1)./kk_unit,-kk_range_set_target(:,2)./kk_unit,'marker','o','markerfacecolor','none','markeredgecolor',[1 1 1],'markersize',2.5,'linestyle','none','linewidth',1);
        plot(kk_range_set_min(:,1)./kk_unit,kk_range_set_min(:,2)./kk_unit,'marker','none','markerfacecolor',clr_avg,'markeredgecolor','none','markersize',2.5,'linestyle',line_style,'color',clr_line,'linewidth',2);
        plot(kk_range_set_max(:,1)./kk_unit,kk_range_set_max(:,2)./kk_unit,'marker','none','markerfacecolor',clr_avg,'markeredgecolor','none','markersize',2.5,'linestyle',line_style,'color',clr_line,'linewidth',2);
        plot(-kk_range_set_min(:,1)./kk_unit,-kk_range_set_min(:,2)./kk_unit,'marker','none','markerfacecolor',clr_avg,'markeredgecolor','none','markersize',2.5,'linestyle',line_style,'color',clr_line,'linewidth',2);
        plot(-kk_range_set_max(:,1)./kk_unit,-kk_range_set_max(:,2)./kk_unit,'marker','none','markerfacecolor',clr_avg,'markeredgecolor','none','markersize',2.5,'linestyle',line_style,'color',clr_line,'linewidth',2);
        colormap(cmap_gen);
        caxis([0 max(max(SS_k_2D./NN)).*0.025]);
        axis([-1 1 -1 1]);
        
        hx=xlabel('{\itk_x} / {\itk}_c');
        hy=ylabel('{\itk_y} / {\itk}_c');
        h=gca;
%         set(h,'Fontname','Helvetica','FontWeight','normal','xtick',[-1 0 1],'ytick',[-1 0 1],'FontSize',font_size_2+10,'PlotBoxAspectRatio',[1 1 1],'linewidth',1,'ydir','normal','xscale','linear');
%         set(hx,'Fontname','Helvetica','FontWeight','normal','FontSize',font_size+16);
%         set(hy,'Fontname','Helvetica','FontWeight','normal','FontSize',font_size+16);
        set(h,'Fontname','Helvetica','FontWeight','normal','xtick',[-1 0 1],'ytick',[-1 0 1],'FontSize',font_size_2,'PlotBoxAspectRatio',[1 1 1],'linewidth',1,'ydir','normal','xscale','linear');
        set(hx,'Fontname','Helvetica','FontWeight','normal','FontSize',font_size);
        set(hy,'Fontname','Helvetica','FontWeight','normal','FontSize',font_size);
        movegui(fig_temp,'west');
        
        cb=colorbar;
%         set(cb,'Position',[0.83 0.775 0.04 0.15],'ytick',[0 0.01 0.02])
        set(cb,'Position',[0.75 0.775 0.04 0.15],'ytick',[0 0.01 0.02])
        figure(plot_num_3);
        save_fig = gcf;
        set(save_fig, 'InvertHardCopy', 'off');
        set(save_fig, 'Color', 'w');
        set(save_fig, 'Position',  [100, 100, 1200, 900]);
            exportgraphics(save_fig,save_file_name_3,'Resolution',500);
        % % %     saveas(gcf,save_file_name_3,'tif');
    
    close all;
    end
    
    
end


% % % % 
% % % %     %% Plotting Particles
% % % %     fig_temp=figure(100000+ti_case);
% % % %     hold on;
% % % %     theta_plot=0:(2.*pi./1000):2.*pi;
% % % %     rr_plot=1;
% % % %     plot(rr_plot.*cos(theta_plot),rr_plot.*sin(theta_plot),'k-');
% % % %     plot(rr_plot.*cos(theta_plot),-rr_plot.*sin(theta_plot),'k-');
% % % %     plot(RR_ROI_min.*cos(theta_plot),RR_ROI_min.*sin(theta_plot),'k-');
% % % %     plot(RR_ROI_min.*cos(theta_plot),-RR_ROI_min.*sin(theta_plot),'k-');
% % % %     
% % % %     clr_pre=[0.2 0.2 0.2];
% % % %     clr_SHU=[0.2 0.2 0.2];
% % % %     
% % % %     for ti_plot=1:1:NN
% % % %         clr_plot=clr_SHU;
% % % %         plot3(rr_vec(ti_plot,1),rr_vec(ti_plot,2),1.*ones(1,1),'marker','o','markerfacecolor',clr_plot,'markeredgecolor',clr_plot,'markersize',5.5,'linestyle','none');
% % % %     end
% % % %     axis off;
% % % %     % plot3(rr_vec(1:1:NN_curr,1),rr_vec(1:1:NN_curr,2),1.*ones(NN_curr,1),'marker','none','markerfacecolor',clr_plot,'markeredgecolor',[0 0.5 0],'markersize',10,'linestyle','--');
% % % %     movegui(fig_temp,'west');
% % % %     
% % % %     
% % % %     %% II. Static Plot - Structure Factor
% % % %     cmap_S_factor;
% % % %     kk_range_set_min(:,1)=kk_ROI_min.*cos(theta_cand_k);
% % % %     kk_range_set_min(:,2)=kk_ROI_min.*sin(theta_cand_k);
% % % %     kk_range_set_max(:,1)=kk_ROI_max.*cos(theta_cand_k);
% % % %     kk_range_set_max(:,2)=kk_ROI_max.*sin(theta_cand_k);
% % % %     fig_temp=figure(200000+ti_case);
% % % %     hold on;
% % % %     clr_avg=[0.4 0.4 0.7];
% % % %     % imagesc(kk_range_axis{1}./kk_unit,kk_range_axis{2}./kk_unit,SS_k_2D./NN);
% % % %     imagesc(kk_range_axis{1}./kk_unit,kk_range_axis{2}./kk_unit,SS_k_2D./NN);
% % % %     % plot(kk_range_set_target(:,1)./kk_unit,kk_range_set_target(:,2)./kk_unit,'marker','o','markerfacecolor','none','markeredgecolor',[1 1 1],'markersize',2.5,'linestyle','none','linewidth',1);
% % % %     % plot(-kk_range_set_target(:,1)./kk_unit,-kk_range_set_target(:,2)./kk_unit,'marker','o','markerfacecolor','none','markeredgecolor',[1 1 1],'markersize',2.5,'linestyle','none','linewidth',1);
% % % %     plot(kk_range_set_min(:,1)./kk_unit,kk_range_set_min(:,2)./kk_unit,'marker','none','markerfacecolor',clr_avg,'markeredgecolor','none','markersize',2.5,'linestyle',line_style,'color',clr_line,'linewidth',2);
% % % %     plot(kk_range_set_max(:,1)./kk_unit,kk_range_set_max(:,2)./kk_unit,'marker','none','markerfacecolor',clr_avg,'markeredgecolor','none','markersize',2.5,'linestyle',line_style,'color',clr_line,'linewidth',2);
% % % %     plot(-kk_range_set_min(:,1)./kk_unit,-kk_range_set_min(:,2)./kk_unit,'marker','none','markerfacecolor',clr_avg,'markeredgecolor','none','markersize',2.5,'linestyle',line_style,'color',clr_line,'linewidth',2);
% % % %     plot(-kk_range_set_max(:,1)./kk_unit,-kk_range_set_max(:,2)./kk_unit,'marker','none','markerfacecolor',clr_avg,'markeredgecolor','none','markersize',2.5,'linestyle',line_style,'color',clr_line,'linewidth',2);
% % % %     colormap(cmap_gen);
% % % %     caxis([0 max(SS_k./NN).*0.025]);
% % % %     axis([-1 1 -1 1]);
% % % %     
% % % %     hx=xlabel('{\itk_x} / {\itk}_c');
% % % %     hy=ylabel('{\itk_y} / {\itk}_c');
% % % %     set(hx,'Fontname','Helvetica','FontWeight','normal','FontSize',font_size);
% % % %     set(hy,'Fontname','Helvetica','FontWeight','normal','FontSize',font_size);
% % % %     h=gca;
% % % %     set(h,'Fontname','Helvetica','FontWeight','normal','xtick',[-1 0 1],'ytick',[-1 0 1],'FontSize',font_size_2,'PlotBoxAspectRatio',[1 1 1],'linewidth',1,'ydir','normal','xscale','linear');
% % % %     movegui(fig_temp,'west');
% % % %     
% % % %     cb=colorbar;
% % % %     set(cb,'Position',[0.80 0.775 0.04 0.15],'ytick',[0 0.01 0.02])
% % % %     
% % % %     
% % % %     figure(100000+ti_case);
% % % %     set(gcf, 'InvertHardCopy', 'off');
% % % %     set(gcf, 'Color', 'w');
% % % %     saveas(gcf,['./Figures/Particle_Position_Evol_Type_',num2str(type_num,'%02i'),'_rng_',num2str(ti_case,'%03i')],'tif');
% % % %     figure(200000+ti_case);
% % % %     set(gcf, 'InvertHardCopy', 'off');
% % % %     set(gcf, 'Color', 'w');
% % % %     saveas(gcf,['./Figures/Structure_Factor_Evol_Type_',num2str(type_num,'%02i'),'_rng_',num2str(ti_case,'%03i')],'tif');
% % % % 
% % % %     close all;
% % % % % close all;
% % % % 
% % % % end
% % % % 
% % % % load(['data_SS_k_2D_avg_Evol_',num2str(type_num,'%02i')]);
% % % % fig_temp=figure(300000);
% % % % hold on;
% % % % clr_avg=[0.4 0.4 0.7];
% % % % % imagesc(kk_range_axis{1}./kk_unit,kk_range_axis{2}./kk_unit,SS_k_2D./NN);
% % % % imagesc(kk_range_axis{1}./kk_unit,kk_range_axis{2}./kk_unit,SS_k_2D_avg./NN);
% % % % % plot(kk_range_set_target(:,1)./kk_unit,kk_range_set_target(:,2)./kk_unit,'marker','o','markerfacecolor','none','markeredgecolor',[1 1 1],'markersize',2.5,'linestyle','none','linewidth',1);
% % % % % plot(-kk_range_set_target(:,1)./kk_unit,-kk_range_set_target(:,2)./kk_unit,'marker','o','markerfacecolor','none','markeredgecolor',[1 1 1],'markersize',2.5,'linestyle','none','linewidth',1);
% % % % plot(kk_range_set_min(:,1)./kk_unit,kk_range_set_min(:,2)./kk_unit,'marker','none','markerfacecolor',clr_avg,'markeredgecolor','none','markersize',2.5,'linestyle',line_style,'color',clr_line,'linewidth',2);
% % % % plot(kk_range_set_max(:,1)./kk_unit,kk_range_set_max(:,2)./kk_unit,'marker','none','markerfacecolor',clr_avg,'markeredgecolor','none','markersize',2.5,'linestyle',line_style,'color',clr_line,'linewidth',2);
% % % % plot(-kk_range_set_min(:,1)./kk_unit,-kk_range_set_min(:,2)./kk_unit,'marker','none','markerfacecolor',clr_avg,'markeredgecolor','none','markersize',2.5,'linestyle',line_style,'color',clr_line,'linewidth',2);
% % % % plot(-kk_range_set_max(:,1)./kk_unit,-kk_range_set_max(:,2)./kk_unit,'marker','none','markerfacecolor',clr_avg,'markeredgecolor','none','markersize',2.5,'linestyle',line_style,'color',clr_line,'linewidth',2);
% % % % colormap(cmap_gen);
% % % % caxis([0 max(SS_k./NN).*0.025]);
% % % % axis([-1 1 -1 1]);
% % % % 
% % % % hx=xlabel('{\itk_x} / {\itk}_c');
% % % % hy=ylabel('{\itk_y} / {\itk}_c');
% % % % set(hx,'Fontname','Helvetica','FontWeight','normal','FontSize',font_size);
% % % % set(hy,'Fontname','Helvetica','FontWeight','normal','FontSize',font_size);
% % % % h=gca;
% % % % set(h,'Fontname','Helvetica','FontWeight','normal','xtick',[-1 0 1],'ytick',[-1 0 1],'FontSize',font_size_2,'PlotBoxAspectRatio',[1 1 1],'linewidth',1,'ydir','normal','xscale','linear');
% % % % movegui(fig_temp,'west');
% % % % 
% % % % cb=colorbar;
% % % % set(cb,'Position',[0.80 0.775 0.04 0.15],'ytick',[0 0.01 0.02])
% % % % 
% % % % figure(300000);
% % % % set(gcf, 'InvertHardCopy', 'off');
% % % % set(gcf, 'Color', 'w');
% % % % saveas(gcf,['./Figures/Structure_Factor_Poisson_Evol_Type_',num2str(type_num,'%02i'),'_avg'],'tif');
% % % % 
% % % % 
% % % % 
% % % % 
% % % % 
