
rng(rng_sim*10);
%% Monte-Carlo Sampling: Real Space
cand_pos_num_init=NN_pre;   % Sampling Number for Spatial Domain
rr_vec_cand_init=zeros(cand_pos_num_init,2);

%% Angular Sampling
theta_grid=linspace(ang_rr_st,ang_rr_ed,cand_pos_num_init+1);
theta_cand=transpose(theta_grid(1:1:(length(theta_grid)-1)));

%% Radial Sampling: Probability Density Function for Radial Distribution
rr_cand_del_init=linspace(0,1,pdf_approx_discrete);

% F_rr_cand_del = rr_cand_del.^DD;    %% Cumulative Distribution Function
% f_rr_cand_del = DD*(rr_cand_del.^(DD-1));    %% Probability Distribution Function

%% 2D CDF & PDF
F_rr_cand_del_init = ((RR_init_max-RR_init_min)./(RR_init_max+RR_init_min)).*rr_cand_del_init.^2+2.*RR_init_min./(RR_init_max+RR_init_min).*rr_cand_del_init;    %% Cumulative Distribution Function
f_rr_cand_del_init = 2.*((RR_init_max-RR_init_min)./(RR_init_max+RR_init_min)).*rr_cand_del_init+2.*RR_init_min./(RR_init_max+RR_init_min);    %% Probability Distribution Function
F_rr_cand_del_init(1)=0;F_rr_cand_del_init(end)=1;

F_dist_init = makedist('PiecewiseLinear', 'x', rr_cand_del_init, 'Fx', F_rr_cand_del_init);    %% Approximation of Probability Distribution Function
rr_cand_init = transpose(random(F_dist_init, 1, cand_pos_num_init));   %% Random Generation

% Position Random Sampling
rr_vec_cand_init(:,1)=rr_vec_init(:,1)+(RR_init_min+rr_cand_init.*(RR_init_max-RR_init_min)).*cos(theta_cand);
rr_vec_cand_init(:,2)=rr_vec_init(:,2)+(RR_init_min+rr_cand_init.*(RR_init_max-RR_init_min)).*sin(theta_cand);
rr_cand_del_fit_init=RR_init_min+rr_cand_del_init.*(RR_init_max-RR_init_min);
