

clear all;
close all;

rng_arr_max=100;
rng_arr=1:1:rng_arr_max;

for ti_rng_scan=1:1:length(rng_arr)

    rng_sim=rng_arr(ti_rng_scan);

    init_param_set;
    [cand_pos_num,rr_vec_cand,cand_kk_num,kk_range_set_target,theta_grid,theta_grid_k,theta_cand,theta_cand_k,rr_cand_del,rr_cand_del_kk,rr_cand_del_fit,rr_cand_del_kk_fit,f_rr_cand_del,f_kk_cand_del,rr_cand,rr_cand_kk]=...
        monte_carlo_setting(monte_num_RR_max,monte_num_km_max,VV_ROI,VV_max,VV_ROI_kk,VV_max_kk,ang_rr_st,ang_rr_ed,ang_kk_st,ang_kk_ed,pdf_approx_discrete,DD,rr_vec_init,RR_ROI_min,RR_ROI_max,kk_ROI_min,kk_ROI_max,rng_sim);

    %% Optimization Process
    %% Monte-Carlo Method
    cost_func_monitor_arr=zeros(NN,1);
    rho_func_prev=0;
    rho_func_prev_arr=zeros(round(monte_num_RR_max.*(VV_ROI./VV_max)),NN);
    weight_degree_arr=zeros(NN,NN);
    preference_ele_arr=zeros(NN,NN);

    %% Tuning of Evolving Process: 220313 Start
    weightpq=zeros(NN,NN);
    weight2MC=zeros(NN,cand_pos_num);
    sz_kk_range_set=size(kk_range_set_target);
    kk_range_set_num=sz_kk_range_set(1);
    rho_mat=0;
    weight_mat=0;
    NN_curr=NN_pre;
    if NN_pre>1
        %% Optimization 2 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        for ti_dim=1:1:DD
            rr_vec_ROI=rr_vec(1:1:NN_curr,ti_dim);
            temp_term_1=rr_vec_ROI*ones(1,cand_pos_num);
            temp_term_2=ones(NN_curr,1)*transpose(rr_vec_cand(:,ti_dim));
            diff_rr_vec_ROI_cand{ti_dim}=temp_term_1-temp_term_2; %% (p,q) = rr_vec(p) - rr_vec_cand(q)

            rr_vec_ROI_pq=rr_vec(1:1:NN_curr,ti_dim);
            temp_term=rr_vec_ROI_pq*ones(1,NN_curr);
            diff_rr_vec_ROI_pq_pre{ti_dim}=temp_term-transpose(temp_term); %% (p,q) = rr_vec(p) - rr_vec(q)
        end
        for ti_kk_target=1:1:kk_range_set_num
            temp_dim_info=zeros(NN_curr,cand_pos_num);
            for ti_dim=1:1:DD
                temp_dim_info=temp_dim_info+kk_range_set_target(ti_kk_target,ti_dim).*diff_rr_vec_ROI_cand{ti_dim};  %% Phase Sum for each pairwise connection
            end
            rho_k_sum=cos(temp_dim_info);
            rho_mat=rho_mat+rho_k_sum;

            temp_dim_info_pq=zeros(NN_curr,NN_curr);
            for ti_dim=1:1:DD
                temp_dim_info_pq=temp_dim_info_pq+kk_range_set_target(ti_kk_target,ti_dim).*diff_rr_vec_ROI_pq_pre{ti_dim};  %% Phase Sum for each pairwise connection
            end
            weight_k_sum=cos(temp_dim_info_pq);
            weight_mat=weight_mat+weight_k_sum;
        end

        weight2MC(1:1:NN_curr,:)=rho_mat./kk_range_set_num;
        weightpq(1:1:NN_curr,1:1:NN_curr)=weight_mat./kk_range_set_num;
        weightpq=weightpq-diag(diag(weightpq));
    end
    weight_degree=sum(weightpq(1:1:NN_curr,1:1:NN_curr),2)-diag(weightpq(1:1:NN_curr,1:1:NN_curr));

    %% Tuning of Evolving Process: 220313 END

    for ti_NN=(NN_pre+1):1:(NN-NN_post)
        if mod(ti_NN,20)==0
            ['Process = ',num2str((ti_NN-2)./(NN-2).*100),'%']
        end
        NN_curr=(ti_NN-1);
        %% Updating Preference based on Evolving Weight Networks
        %             [rr_vec,cost_func_monitor,rho_func,weight_degree,preference_ele]=generative_function_MC_prefer_dynamic(rr_vec,NN_curr,rr_vec_cand,kk_range_set_target,HU_aHU,prefer_type);

        %% Tuning of Evolving Process: 220313 Start
        [rr_vec,cost_func_monitor,rho_func,weight_degree,preference_ele,weight2MC,weightpq,NN_curr]=generative_function_MC_prefer_dynamic_tuning(rr_vec,NN_curr,rr_vec_cand,kk_range_set_target,HU_aHU,weight2MC,weightpq,weight_degree,prefer_type);

        %% Tuning of Evolving Process: 220313 END

        weight_degree_arr(1:1:NN_curr,ti_NN)=weight_degree;
        preference_ele_arr(1:1:(NN_curr-1),ti_NN)=preference_ele;

        rho_func_prev=rho_func;
        rho_func_prev_arr(:,ti_NN)=rho_func_prev;
        cost_func_monitor_arr(ti_NN)=cost_func_monitor;
    end
    preference_calc;
    preference_ele_arr(1:1:NN_curr,ti_NN)=preference_ele;

    if NN_post>0
        post_dist_update;
        rr_vec(((NN-NN_post+1):1:NN),:)=rr_vec_cand_post;

        for ti_NN=(NN-NN_post+1):1:NN
            NN_curr=NN_curr+1;
            %% Weight Update
            % %% Optimization Code 2 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            temp_phase_tot_pq=zeros(kk_range_set_num,NN_curr);
            for ti_dim=1:1:DD
                rr_vec_ROI_pq=rr_vec(1:1:NN_curr,ti_dim);
                temp_term_1=rr_vec_ROI_pq(NN_curr).*ones(1,NN_curr);
                temp_term_2=transpose(rr_vec_ROI_pq);
                diff_rr_vec_ROI_pq_post{ti_dim}=temp_term_1-temp_term_2; %% (p,q) = rr_vec(p) - rr_vec_cand(q)
                temp_phase_pq_post{ti_dim}=kk_range_set_target(:,ti_dim)*diff_rr_vec_ROI_pq_post{ti_dim};
                temp_phase_tot_pq=temp_phase_tot_pq+temp_phase_pq_post{ti_dim};
            end
            weight_arr_N_curr=sum(cos(temp_phase_tot_pq),1)./kk_range_set_num;
            weightpq(NN_curr,1:1:NN_curr)=weight_arr_N_curr;
            weightpq(1:1:NN_curr,NN_curr)=transpose(weight_arr_N_curr);
            weightpq=weightpq-diag(diag(weightpq));
            weight_degree=sum(weightpq(1:1:NN_curr,1:1:NN_curr),2)-diag(weightpq(1:1:NN_curr,1:1:NN_curr));
            % % %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

        end
    end

    %% Structural Factor Calculation
    kk_del_fac=0.1;
    [SS_k,kk_range_set,kk_range_axis,kk_del,kk_axis_num,kk_comb_num]=structure_factor_specific(rr_vec,kk_max,RR_max,kk_del_fac);
    ['S-Factor END!']

    %% Structure Factor 2D Conversion
    SS_k_2D=reshape(SS_k,kk_axis_num(1),kk_axis_num(2));
    [kk_range_axis_grid{1},kk_range_axis_grid{2}]=meshgrid(kk_range_axis{1},kk_range_axis{2});

    %% Structure Factor ROI Analysis
    kk_range_rr_grid=sqrt(kk_range_axis_grid{1}.^2+kk_range_axis_grid{2}.^2);
    kk_ROI_ind=(kk_range_rr_grid>=kk_ROI_min)&(kk_range_rr_grid<=kk_ROI_max); kk_ROI_ind_1D=kk_ROI_ind(:);
    kk_non_ROI_inner_ind=(kk_range_rr_grid<kk_ROI_min); kk_non_ROI_inner_ind_1D=kk_non_ROI_inner_ind(:);
    kk_non_ROI_outer_ind=(kk_range_rr_grid>kk_ROI_max)&(kk_range_rr_grid<=kk_max); kk_non_ROI_outer_ind_1D=kk_non_ROI_outer_ind(:);
    kk_non_ROI=kk_non_ROI_inner_ind+kk_non_ROI_outer_ind; kk_non_ROI_1D=kk_non_ROI(:);
    kk_max_ind=(kk_range_rr_grid<=kk_max); kk_max_ind_1D=kk_max_ind(:);

    %% Weight SS_k estimation
    weightpq_SS_k=zeros(NN,NN);
    weightpq_SS_k_inner=zeros(NN,NN);
    weightpq_SS_k_outer=zeros(NN,NN);
    diff_rr_vec_ROI_pq=zeros(2,NN);
    % %% Optimization Code 2 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    for ti_NN=1:1:NN
        temp_term_1=transpose(rr_vec(ti_NN,:)).*ones(1,NN);
        temp_term_2=transpose(rr_vec);
        diff_rr_vec_ROI_pq=temp_term_1-temp_term_2; %% (p,q) = rr_vec(p) - rr_vec_cand(q)
        temp_phase_pq=kk_range_set(kk_ROI_ind_1D,:)*diff_rr_vec_ROI_pq;
        temp_phase_pq_inner=kk_range_set(kk_non_ROI_inner_ind_1D,:)*diff_rr_vec_ROI_pq;
        temp_phase_pq_outer=kk_range_set(kk_non_ROI_outer_ind_1D,:)*diff_rr_vec_ROI_pq;
        weightpq_SS_k(ti_NN,:)=sum(cos(temp_phase_pq),1)./sum(kk_ROI_ind_1D);
        weightpq_SS_k_inner(ti_NN,:)=sum(cos(temp_phase_pq_inner),1)./sum(kk_non_ROI_inner_ind_1D);
        weightpq_SS_k_outer(ti_NN,:)=sum(cos(temp_phase_pq_outer),1)./sum(kk_non_ROI_outer_ind_1D);
    end
    weightpq_SS_k=weightpq_SS_k-diag(diag(weightpq_SS_k));
    weightpq_SS_k_inner=weightpq_SS_k_inner-diag(diag(weightpq_SS_k_inner));
    weightpq_SS_k_outer=weightpq_SS_k_outer-diag(diag(weightpq_SS_k_outer));
    weight_degree_SS_k=sum(weightpq_SS_k,2)-diag(weightpq_SS_k);
    weight_degree_SS_k_inner=sum(weightpq_SS_k_inner,2)-diag(weightpq_SS_k_inner);
    weight_degree_SS_k_outer=sum(weightpq_SS_k_outer,2)-diag(weightpq_SS_k_outer);
    % % %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


    %% Evolution of SS_k
    SS_k_evol_training=zeros(1,NN);
    SS_k_evol=zeros(1,NN);
    SS_k_evol_inner=zeros(1,NN);
    SS_k_evol_outer=zeros(1,NN);

    for ti_temp=1:1:NN
        SS_k_evol_training(ti_temp)=1+mean(sum(weightpq(1:1:ti_temp,1:1:ti_temp),1)); 
        SS_k_evol(ti_temp)=1+mean(sum(weightpq_SS_k(1:1:ti_temp,1:1:ti_temp),1)); 
        SS_k_evol_inner(ti_temp)=1+mean(sum(weightpq_SS_k_inner(1:1:ti_temp,1:1:ti_temp),1)); 
        SS_k_evol_outer(ti_temp)=1+mean(sum(weightpq_SS_k_outer(1:1:ti_temp,1:1:ti_temp),1)); 
    end

    %% Saving Data Files
    data_file_name=['./Data/Pref_',num2str(prefer_type,'%03i'),'_NN_',num2str(NN,'%05i'),'_k_max_',num2str(round(1e2.*km_ROI_max),'%03i'),'_min_',num2str(round(1e2.*km_ROI_min),'%03i'),'_NN_pre_',num2str(NN_pre,'%05i'),'_NN_post_',num2str(NN_post,'%05i'),'_rng_',num2str(rng_param,'%03i')]
    save(data_file_name);

end




