
rng(rng_sim*20);
%% Monte-Carlo Sampling: Real Space
cand_pos_num_post=NN_post;   % Sampling Number for Spatial Domain
rr_vec_cand_post=zeros(cand_pos_num_post,2);

%% Angular Sampling
theta_grid=linspace(ang_rr_st,ang_rr_ed,cand_pos_num_post+1);
theta_cand=transpose(theta_grid(1:1:(length(theta_grid)-1)));

%% Radial Sampling: Probability Density Function for Radial Distribution
rr_cand_del_post=linspace(0,1,pdf_approx_discrete);

% F_rr_cand_del = rr_cand_del.^DD;    %% Cumulative Distribution Function
% f_rr_cand_del = DD*(rr_cand_del.^(DD-1));    %% Probability Distribution Function

%% 2D CDF & PDF
F_rr_cand_del_post = ((RR_post_max-RR_post_min)./(RR_post_max+RR_post_min)).*rr_cand_del_post.^2+2.*RR_post_min./(RR_post_max+RR_post_min).*rr_cand_del_post;    %% Cumulative Distribution Function
f_rr_cand_del_post = 2.*((RR_post_max-RR_post_min)./(RR_post_max+RR_post_min)).*rr_cand_del_post+2.*RR_post_min./(RR_post_max+RR_post_min);    %% Probability Distribution Function
F_rr_cand_del_post(1)=0;F_rr_cand_del_post(end)=1;

F_dist_post = makedist('PiecewiseLinear', 'x', rr_cand_del_post, 'Fx', F_rr_cand_del_post);    %% Approximation of Probability Distribution Function
rr_cand_post = transpose(random(F_dist_post, 1, cand_pos_num_post));   %% Random Generation

% Position Random Sampling
rr_vec_cand_post(:,1)=rr_vec_init(:,1)+(RR_post_min+rr_cand_post.*(RR_post_max-RR_post_min)).*cos(theta_cand);
rr_vec_cand_post(:,2)=rr_vec_init(:,2)+(RR_post_min+rr_cand_post.*(RR_post_max-RR_post_min)).*sin(theta_cand);
rr_cand_del_fit_post=RR_post_min+rr_cand_del_post.*(RR_post_max-RR_post_min);
