
function [SS_k,kk_range_set,kk_range_axis,kk_del,kk_axis_num,kk_comb_num]=structure_factor_specific(rr_vec,kk_max,RR_max,kk_del_fac)

%% System Parameters
temp=size(rr_vec);
NN=temp(1);
DD=temp(2);

%% k element setting
kk_del=2.*pi./RR_max.*kk_del_fac;
kk_discre_num=round(2.*kk_max./kk_del); if mod(kk_discre_num,2)==0; kk_discre_num=kk_discre_num+1; end;    %% Odd number discretization for including 0 points

for ti_DD=1:1:DD
    if DD==2
        if ti_DD==1
            kk_range_axis{ti_DD}=linspace(-kk_max,kk_max,kk_discre_num);
            kk_axis_num(1,ti_DD)=length(kk_range_axis{ti_DD});
        else
            kk_range_axis{ti_DD}=linspace(0,kk_max,round((kk_discre_num-1)/2+1));
            kk_axis_num(1,ti_DD)=length(kk_range_axis{ti_DD});
        end
    else
        kk_range_axis{ti_DD}=-kk_max:kk_del:kk_max;
        kk_axis_num(1,ti_DD)=length(kk_range_axis{ti_DD});
    end
end
kk_del=kk_range_axis{1}(2)-kk_range_axis{1}(1);

kk_comb_num=prod(kk_axis_num);
temp_kk_range_set=kk_range_axis{1};
if DD>1
    for ti_DD=1:1:(DD-1)
        temp_kk_range_set=combvec(temp_kk_range_set,kk_range_axis{ti_DD+1});
    end
end
kk_range_set=transpose(temp_kk_range_set);
% plot(kk_range_set(:,1),kk_range_set(:,2),'marker','o','linestyle','none');

%% Structure Factor Calculation
SS_k=zeros(kk_comb_num,1);
[dist_vec_info]=dist_vec_calc(rr_vec,NN);

% %% Basic Code
% for ti_kk=1:1:kk_comb_num    
%     temp_kk_sum=0;
%     for ti_ed=1:1:NN-1
%         for ti_st=(ti_ed+1):1:NN
% %             temp_kk_sum=temp_kk_sum+cos(dot(kk_range_set(ti_kk,:),(rr_vec(ti_ed,:)-rr_vec(ti_st,:))));
%             temp_kk_sum=temp_kk_sum+cos(sum(kk_range_set(ti_kk,:).*(rr_vec(ti_ed,:)-rr_vec(ti_st,:))));
%         end
%     end   
%     temp_kk_sum=temp_kk_sum.*2./NN;
%     SS_k(ti_kk)=1+temp_kk_sum;    
% end
% 
% %% Optimized Code
% for ti_kk=1:1:kk_comb_num      
%     
%     if mod(ti_kk,20000)==0
%         ['S-Factor Process = ',num2str((ti_kk-1)./(kk_comb_num-1).*100),'%']
%     end
%     
%     temp_kk_sum=0;
%     
%     for ti_DD=1:1:DD
%         temp_kk_sum=temp_kk_sum+kk_range_set(ti_kk,ti_DD).*dist_vec_info{ti_DD};
%     end
%     
%     SS_k(ti_kk)=1+(2./NN).*sum(sum(tril(cos(temp_kk_sum),-1)));
% end

%% Optimized Code 2
sz_dist_vec=size(dist_vec_info{ti_DD});
tril_mat=tril(ones(sz_dist_vec),-1);
rr_dist_vec=zeros(DD,sum(sum(tril_mat)));
for ti_DD=1:1:DD
    rr_dist_vec(ti_DD,:)=dist_vec_info{ti_DD}(tril_mat==1);
end

phase_axis=kk_range_set*rr_dist_vec;
SS_k=1+(2./NN).*sum(cos(phase_axis),2);


if DD==2
    kk_range_set=[kk_range_set((kk_comb_num:-1:(length(kk_range_axis{1})+1)),:);kk_range_set];
    SS_k=[SS_k(kk_comb_num:-1:(length(kk_range_axis{1})+1));SS_k];
    kk_range_axis{2}=linspace(-kk_max,kk_max,kk_discre_num);
    kk_axis_num(1,2)=length(kk_range_axis{2});
    kk_comb_num=prod(kk_axis_num);
end

%% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%














