
function [rr_vec,cost_func_monitor,rho_func,weight_degree,preference_ele,weight2MC,weightpq,NN_curr]=generative_function_MC_prefer_dynamic_tuning(rr_vec,NN_curr,rr_vec_cand,kk_range_set_target,HU_aHU,weight2MC,weightpq,weight_degree,prefer_type)

%% Structural Parameters
temp=size(rr_vec);
NN=temp(1);
DD=temp(2);
sz_kk_range_set=size(kk_range_set_target);
kk_range_set_num=sz_kk_range_set(1);
sz_rr_vec_cand=size(rr_vec_cand);
monte_num_RR_max=sz_rr_vec_cand(1);

%% Preference Update
preference_calc;
preference_mat=transpose(preference_ele)*ones(1,monte_num_RR_max);

% %% Optimization Code 1 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% temp_phase_tot=zeros(kk_range_set_num,monte_num_RR_max);
% for ti_dim=1:1:DD
%     rr_vec_ROI=rr_vec(1:1:NN_curr,ti_dim);
%     temp_term_1=rr_vec_ROI(NN_curr).*ones(1,monte_num_RR_max);
%     temp_term_2=transpose(rr_vec_cand(:,ti_dim));
%     diff_rr_vec_ROI_cand{ti_dim}=temp_term_1-temp_term_2; %% (p,q) = rr_vec(p) - rr_vec_cand(q)
%     temp_phase{ti_dim}=kk_range_set_target(:,ti_dim)*diff_rr_vec_ROI_cand{ti_dim};
%     temp_phase_tot=temp_phase_tot+temp_phase{ti_dim};
% end
% rho_mat=sum(cos(temp_phase_tot),1)./kk_range_set_num;
% weight2MC(NN_curr,:)=rho_mat;
% 
% rho_func=transpose(2.*sum((preference_mat.*weight2MC(1:1:NN_curr,:)),1)./NN_curr);
% % %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%% Cost Function from current particle distributions %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
rho_func=transpose(2.*sum((preference_mat.*weight2MC(1:1:NN_curr,:)),1)./NN_curr);
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%% Finding the Optimum Point
%% Target Design: Hyperuniformity & Anti-Hyperuniformity
if HU_aHU==1
    %% Hyperuniformity
    [min_Y,min_ind]=min(rho_func);
else
    %% Anti-Hyperuniformity
    [min_Y,min_ind]=max(rho_func);
end
rr_vec(NN_curr+1,:)=rr_vec_cand(min_ind,:);
cost_func_monitor=min_Y;

%% Particle Number Update
NN_curr=NN_curr+1;

%% Weight Update
% %% Optimization Code 2 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
temp_phase_tot_pq=zeros(kk_range_set_num,NN_curr);
for ti_dim=1:1:DD
    rr_vec_ROI_pq=rr_vec(1:1:NN_curr,ti_dim);
    temp_term_1=rr_vec_ROI_pq(NN_curr).*ones(1,NN_curr);
    temp_term_2=transpose(rr_vec_ROI_pq);
    diff_rr_vec_ROI_pq{ti_dim}=temp_term_1-temp_term_2; %% (p,q) = rr_vec(p) - rr_vec_cand(q)
    temp_phase_pq{ti_dim}=kk_range_set_target(:,ti_dim)*diff_rr_vec_ROI_pq{ti_dim};
    temp_phase_tot_pq=temp_phase_tot_pq+temp_phase_pq{ti_dim};
end
weight_arr_N_curr=sum(cos(temp_phase_tot_pq),1)./kk_range_set_num;
weightpq(NN_curr,1:1:NN_curr)=weight_arr_N_curr;
weightpq(1:1:NN_curr,NN_curr)=transpose(weight_arr_N_curr);
weightpq=weightpq-diag(diag(weightpq));
weight_degree=sum(weightpq(1:1:NN_curr,1:1:NN_curr),2)-diag(weightpq(1:1:NN_curr,1:1:NN_curr));
% % %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%% Optimization Code 2 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
temp_term_1=transpose(rr_vec(NN_curr,:)).*ones(1,monte_num_RR_max);
temp_term_2=transpose(rr_vec_cand);
diff_rr_vec_ROI_cand=temp_term_1-temp_term_2; %% (p,q) = rr_vec(p) - rr_vec_cand(q)
temp_phase_tot=kk_range_set_target*diff_rr_vec_ROI_cand;
rho_mat=sum(cos(temp_phase_tot),1)./kk_range_set_num;
weight2MC(NN_curr,:)=rho_mat;
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%











