
clear all;
close all;

mkdir('./Hist_Data/');
%% Pre-running Code: PROC_degree_S_factor_Evol_Crystals.m

% rng_arr=11:2:29;
% load(['../Crystals/NN_arr.mat']);

%%
km_ROI_max=0.5;
km_ROI_min=0.05;

rng_arr_max=1;
NN_arr=[149, 253, 377, 385, 401, 408, 432, 529];

for ti_NN=1:1:length(NN_arr)
    
    NN=NN_arr(ti_NN);

    %%
    km_ROI_max=0.5;
    km_ROI_min=0.05;
    NN_pre=1;
    NN_post=0;

    load_file_name=['./Post_Proc_data/Post_Data_Crystal_NN_',num2str(NN,'%05i'),'_k_max_',num2str(round(1e2.*km_ROI_max),'%03i'),'_min_',num2str(round(1e2.*km_ROI_min),'%03i')]
    load(load_file_name);


    %% Inportant Parameter for Histogram
    degree_max_global=10;
    hist_grid_global=200;
%     degree_max_global_training=10;
%     hist_grid_global_training=200;
    degree_max_global_inner=300;
    hist_grid_global_inner=300;
    degree_max_global_outer=10;
    hist_grid_global_outer=200;

    for ti_EVOL=1:1:NN

        ['Process = ',num2str((ti_EVOL-1)./(NN-1)*100),'%']

        hist_edge_degree_evol{ti_EVOL}=linspace(-degree_max_global,degree_max_global,hist_grid_global);
        hist_cent_degree_evol{ti_EVOL}=hist_edge_degree_evol{ti_EVOL}(1:1:(length(hist_edge_degree_evol{ti_EVOL})-1))+diff(hist_edge_degree_evol{ti_EVOL})./2;
        [degree_vec_hist_evol{ti_EVOL},hist_edge_degree_evol{ti_EVOL}] = histcounts(weight_degree_SS_k_arr{ti_EVOL},hist_edge_degree_evol{ti_EVOL});


%         hist_edge_degree_evol_training{ti_EVOL}=linspace(-degree_max_global_training,degree_max_global_training,hist_grid_global_training);
%         hist_cent_degree_evol_training{ti_EVOL}=hist_edge_degree_evol_training{ti_EVOL}(1:1:(length(hist_edge_degree_evol_training{ti_EVOL})-1))+diff(hist_edge_degree_evol_training{ti_EVOL})./2;
%         [degree_vec_hist_evol_training{ti_EVOL},hist_edge_degree_evol_training{ti_EVOL}] = histcounts(weight_degree_training_arr{ti_EVOL},hist_edge_degree_evol_training{ti_EVOL});


        hist_edge_degree_evol_inner{ti_EVOL}=linspace(-degree_max_global_inner,degree_max_global_inner,hist_grid_global_inner);
        hist_cent_degree_evol_inner{ti_EVOL}=hist_edge_degree_evol_inner{ti_EVOL}(1:1:(length(hist_edge_degree_evol_inner{ti_EVOL})-1))+diff(hist_edge_degree_evol_inner{ti_EVOL})./2;
        [degree_vec_hist_evol_inner{ti_EVOL},hist_edge_degree_evol_inner{ti_EVOL}] = histcounts(weight_degree_SS_k_inner_arr{ti_EVOL},hist_edge_degree_evol_inner{ti_EVOL});


        hist_edge_degree_evol_outer{ti_EVOL}=linspace(-degree_max_global_outer,degree_max_global_outer,hist_grid_global_outer);
        hist_cent_degree_evol_outer{ti_EVOL}=hist_edge_degree_evol_outer{ti_EVOL}(1:1:(length(hist_edge_degree_evol_outer{ti_EVOL})-1))+diff(hist_edge_degree_evol_outer{ti_EVOL})./2;
        [degree_vec_hist_evol_outer{ti_EVOL},hist_edge_degree_evol_outer{ti_EVOL}] = histcounts(weight_degree_SS_k_outer_arr{ti_EVOL},hist_edge_degree_evol_outer{ti_EVOL});

        %% Asymmetry Analysis
        [degree_vec_hist_max_evol(ti_EVOL),hist_max_ind_evol(ti_EVOL)]=max(degree_vec_hist_evol{ti_EVOL});
        degree_vec_hist_half_evol(ti_EVOL)=degree_vec_hist_max_evol(ti_EVOL)./2;
        [Y,hist_half_ind_L_evol(ti_EVOL)]=min(abs(degree_vec_hist_evol{ti_EVOL}(1:1:hist_max_ind_evol(ti_EVOL))-degree_vec_hist_half_evol(ti_EVOL)));
        [Y,hist_half_ind_R_temp_evol(ti_EVOL)]=min(abs(degree_vec_hist_evol{ti_EVOL}((hist_max_ind_evol(ti_EVOL)+1):1:end)-degree_vec_hist_half_evol(ti_EVOL)));
        hist_half_ind_R_evol(ti_EVOL)=hist_half_ind_R_temp_evol(ti_EVOL)+hist_max_ind_evol(ti_EVOL);
        asymmetry_fac_ind_evol(ti_EVOL)=(hist_half_ind_R_evol(ti_EVOL)-hist_max_ind_evol(ti_EVOL))./(hist_max_ind_evol(ti_EVOL)-hist_half_ind_L_evol(ti_EVOL));
        FWHM_evol(ti_EVOL)=hist_cent_degree_evol{ti_EVOL}(hist_half_ind_R_evol(ti_EVOL))-hist_cent_degree_evol{ti_EVOL}(hist_half_ind_L_evol(ti_EVOL));

        %% Interpolation
        hist_cent_degree_evol_interp{ti_EVOL}=linspace(-max(abs(hist_cent_degree_evol{ti_EVOL})),max(abs(hist_cent_degree_evol{ti_EVOL})),1000);
        degree_vec_hist_evol_interp{ti_EVOL}=interp1(hist_cent_degree_evol{ti_EVOL},degree_vec_hist_evol{ti_EVOL},hist_cent_degree_evol_interp{ti_EVOL},'cubic');
        degree_vec_hist_evol_interp{ti_EVOL}(isnan(degree_vec_hist_evol_interp{ti_EVOL})~=0)=0;

        [degree_vec_hist_max_evol_interp{ti_EVOL},hist_max_ind_evol_interp(ti_EVOL)]=max(degree_vec_hist_evol_interp{ti_EVOL});
        degree_vec_hist_half_evol_interp(ti_EVOL)=degree_vec_hist_max_evol_interp{ti_EVOL}./2;
        [Y,hist_half_ind_L_evol_interp(ti_EVOL)]=min(abs(degree_vec_hist_evol_interp{ti_EVOL}(1:1:hist_max_ind_evol_interp(ti_EVOL))-degree_vec_hist_half_evol_interp(ti_EVOL)));
        [Y,hist_half_ind_R_temp_evol_interp(ti_EVOL)]=min(abs(degree_vec_hist_evol_interp{ti_EVOL}((hist_max_ind_evol_interp(ti_EVOL)+1):1:end)-degree_vec_hist_half_evol_interp(ti_EVOL)));
        hist_half_ind_R_evol_interp(ti_EVOL)=hist_half_ind_R_temp_evol_interp(ti_EVOL)+hist_max_ind_evol_interp(ti_EVOL);
        asymmetry_fac_ind_evol_interp(ti_EVOL)=(hist_half_ind_R_evol_interp(ti_EVOL)-hist_max_ind_evol_interp(ti_EVOL))./(hist_max_ind_evol_interp(ti_EVOL)-hist_half_ind_L_evol_interp(ti_EVOL));
        FWHM_evol_interp(ti_EVOL)=hist_cent_degree_evol_interp{ti_EVOL}(hist_half_ind_R_evol_interp(ti_EVOL))-hist_cent_degree_evol_interp{ti_EVOL}(hist_half_ind_L_evol_interp(ti_EVOL));

%         %% Training: Asymmetry Analysis
%         [degree_vec_hist_max_evol_training(ti_EVOL),hist_max_ind_evol_training(ti_EVOL)]=max(degree_vec_hist_evol_training{ti_EVOL});
%         degree_vec_hist_half_evol_training(ti_EVOL)=degree_vec_hist_max_evol_training(ti_EVOL)./2;
%         [Y,hist_half_ind_L_evol_training(ti_EVOL)]=min(abs(degree_vec_hist_evol_training{ti_EVOL}(1:1:hist_max_ind_evol_training(ti_EVOL))-degree_vec_hist_half_evol_training(ti_EVOL)));
%         [Y,hist_half_ind_R_temp_evol_training(ti_EVOL)]=min(abs(degree_vec_hist_evol_training{ti_EVOL}((hist_max_ind_evol_training(ti_EVOL)+1):1:end)-degree_vec_hist_half_evol_training(ti_EVOL)));
%         hist_half_ind_R_evol_training(ti_EVOL)=hist_half_ind_R_temp_evol_training(ti_EVOL)+hist_max_ind_evol_training(ti_EVOL);
%         asymmetry_fac_ind_evol_training(ti_EVOL)=(hist_half_ind_R_evol_training(ti_EVOL)-hist_max_ind_evol_training(ti_EVOL))./(hist_max_ind_evol_training(ti_EVOL)-hist_half_ind_L_evol_training(ti_EVOL));
%         FWHM_evol_training(ti_EVOL)=hist_cent_degree_evol_training{ti_EVOL}(hist_half_ind_R_evol_training(ti_EVOL))-hist_cent_degree_evol_training{ti_EVOL}(hist_half_ind_L_evol_training(ti_EVOL));
% 
%         %% Training: Interpolation
%         hist_cent_degree_evol_training_interp{ti_EVOL}=linspace(-max(abs(hist_cent_degree_evol_training{ti_EVOL})),max(abs(hist_cent_degree_evol_training{ti_EVOL})),1000);
%         degree_vec_hist_evol_training_interp{ti_EVOL}=interp1(hist_cent_degree_evol_training{ti_EVOL},degree_vec_hist_evol_training{ti_EVOL},hist_cent_degree_evol_training_interp{ti_EVOL},'cubic');
%         degree_vec_hist_evol_training_interp{ti_EVOL}(isnan(degree_vec_hist_evol_training_interp{ti_EVOL})~=0)=0;
% 
%         [degree_vec_hist_max_evol_training_interp{ti_EVOL},hist_max_ind_evol_training_interp(ti_EVOL)]=max(degree_vec_hist_evol_training_interp{ti_EVOL});
%         degree_vec_hist_half_evol_training_interp(ti_EVOL)=degree_vec_hist_max_evol_training_interp{ti_EVOL}./2;
%         [Y,hist_half_ind_L_evol_training_interp(ti_EVOL)]=min(abs(degree_vec_hist_evol_training_interp{ti_EVOL}(1:1:hist_max_ind_evol_training_interp(ti_EVOL))-degree_vec_hist_half_evol_training_interp(ti_EVOL)));
%         [Y,hist_half_ind_R_temp_evol_training_interp(ti_EVOL)]=min(abs(degree_vec_hist_evol_training_interp{ti_EVOL}((hist_max_ind_evol_training_interp(ti_EVOL)+1):1:end)-degree_vec_hist_half_evol_training_interp(ti_EVOL)));
%         hist_half_ind_R_evol_training_interp(ti_EVOL)=hist_half_ind_R_temp_evol_training_interp(ti_EVOL)+hist_max_ind_evol_training_interp(ti_EVOL);
%         asymmetry_fac_ind_evol_training_interp(ti_EVOL)=(hist_half_ind_R_evol_training_interp(ti_EVOL)-hist_max_ind_evol_training_interp(ti_EVOL))./(hist_max_ind_evol_training_interp(ti_EVOL)-hist_half_ind_L_evol_training_interp(ti_EVOL));
%         FWHM_evol_training_interp(ti_EVOL)=hist_cent_degree_evol_training_interp{ti_EVOL}(hist_half_ind_R_evol_training_interp(ti_EVOL))-hist_cent_degree_evol_training_interp{ti_EVOL}(hist_half_ind_L_evol_training_interp(ti_EVOL));

        %% Inner: Asymmetry Analysis
        [degree_vec_hist_max_evol_inner(ti_EVOL),hist_max_ind_evol_inner(ti_EVOL)]=max(degree_vec_hist_evol_inner{ti_EVOL});
        degree_vec_hist_half_evol_inner(ti_EVOL)=degree_vec_hist_max_evol_inner(ti_EVOL)./2;
        [Y,hist_half_ind_L_evol_inner(ti_EVOL)]=min(abs(degree_vec_hist_evol_inner{ti_EVOL}(1:1:hist_max_ind_evol_inner(ti_EVOL))-degree_vec_hist_half_evol_inner(ti_EVOL)));
        [Y,hist_half_ind_R_temp_evol_inner(ti_EVOL)]=min(abs(degree_vec_hist_evol_inner{ti_EVOL}((hist_max_ind_evol_inner(ti_EVOL)+1):1:end)-degree_vec_hist_half_evol_inner(ti_EVOL)));
        hist_half_ind_R_evol_inner(ti_EVOL)=hist_half_ind_R_temp_evol_inner(ti_EVOL)+hist_max_ind_evol_inner(ti_EVOL);
        asymmetry_fac_ind_evol_inner(ti_EVOL)=(hist_half_ind_R_evol_inner(ti_EVOL)-hist_max_ind_evol_inner(ti_EVOL))./(hist_max_ind_evol_inner(ti_EVOL)-hist_half_ind_L_evol_inner(ti_EVOL));
        FWHM_evol_inner(ti_EVOL)=hist_cent_degree_evol_inner{ti_EVOL}(hist_half_ind_R_evol_inner(ti_EVOL))-hist_cent_degree_evol_inner{ti_EVOL}(hist_half_ind_L_evol_inner(ti_EVOL));

        %% Inner: Interpolation
        hist_cent_degree_evol_inner_interp{ti_EVOL}=linspace(-max(abs(hist_cent_degree_evol_inner{ti_EVOL})),max(abs(hist_cent_degree_evol_inner{ti_EVOL})),1000);
        degree_vec_hist_evol_inner_interp{ti_EVOL}=interp1(hist_cent_degree_evol_inner{ti_EVOL},degree_vec_hist_evol_inner{ti_EVOL},hist_cent_degree_evol_inner_interp{ti_EVOL},'cubic');
        degree_vec_hist_evol_inner_interp{ti_EVOL}(isnan(degree_vec_hist_evol_inner_interp{ti_EVOL})~=0)=0;

        [degree_vec_hist_max_evol_inner_interp{ti_EVOL},hist_max_ind_evol_inner_interp(ti_EVOL)]=max(degree_vec_hist_evol_inner_interp{ti_EVOL});
        degree_vec_hist_half_evol_inner_interp(ti_EVOL)=degree_vec_hist_max_evol_inner_interp{ti_EVOL}./2;
        [Y,hist_half_ind_L_evol_inner_interp(ti_EVOL)]=min(abs(degree_vec_hist_evol_inner_interp{ti_EVOL}(1:1:hist_max_ind_evol_inner_interp(ti_EVOL))-degree_vec_hist_half_evol_inner_interp(ti_EVOL)));
        [Y,hist_half_ind_R_temp_evol_inner_interp(ti_EVOL)]=min(abs(degree_vec_hist_evol_inner_interp{ti_EVOL}((hist_max_ind_evol_inner_interp(ti_EVOL)+1):1:end)-degree_vec_hist_half_evol_inner_interp(ti_EVOL)));
        hist_half_ind_R_evol_inner_interp(ti_EVOL)=hist_half_ind_R_temp_evol_inner_interp(ti_EVOL)+hist_max_ind_evol_inner_interp(ti_EVOL);
        asymmetry_fac_ind_evol_inner_interp(ti_EVOL)=(hist_half_ind_R_evol_inner_interp(ti_EVOL)-hist_max_ind_evol_inner_interp(ti_EVOL))./(hist_max_ind_evol_inner_interp(ti_EVOL)-hist_half_ind_L_evol_inner_interp(ti_EVOL));
        FWHM_evol_inner_interp(ti_EVOL)=hist_cent_degree_evol_inner_interp{ti_EVOL}(hist_half_ind_R_evol_inner_interp(ti_EVOL))-hist_cent_degree_evol_inner_interp{ti_EVOL}(hist_half_ind_L_evol_inner_interp(ti_EVOL));

        %% Outer: Asymmetry Analysis
        [degree_vec_hist_max_evol_outer(ti_EVOL),hist_max_ind_evol_outer(ti_EVOL)]=max(degree_vec_hist_evol_outer{ti_EVOL});
        degree_vec_hist_half_evol_outer(ti_EVOL)=degree_vec_hist_max_evol_outer(ti_EVOL)./2;
        [Y,hist_half_ind_L_evol_outer(ti_EVOL)]=min(abs(degree_vec_hist_evol_outer{ti_EVOL}(1:1:hist_max_ind_evol_outer(ti_EVOL))-degree_vec_hist_half_evol_outer(ti_EVOL)));
        [Y,hist_half_ind_R_temp_evol_outer(ti_EVOL)]=min(abs(degree_vec_hist_evol_outer{ti_EVOL}((hist_max_ind_evol_outer(ti_EVOL)+1):1:end)-degree_vec_hist_half_evol_outer(ti_EVOL)));
        hist_half_ind_R_evol_outer(ti_EVOL)=hist_half_ind_R_temp_evol_outer(ti_EVOL)+hist_max_ind_evol_outer(ti_EVOL);
        asymmetry_fac_ind_evol_outer(ti_EVOL)=(hist_half_ind_R_evol_outer(ti_EVOL)-hist_max_ind_evol_outer(ti_EVOL))./(hist_max_ind_evol_outer(ti_EVOL)-hist_half_ind_L_evol_outer(ti_EVOL));
        FWHM_evol_outer(ti_EVOL)=hist_cent_degree_evol_outer{ti_EVOL}(hist_half_ind_R_evol_outer(ti_EVOL))-hist_cent_degree_evol_outer{ti_EVOL}(hist_half_ind_L_evol_outer(ti_EVOL));

        %% Outer: Interpolation
        hist_cent_degree_evol_outer_interp{ti_EVOL}=linspace(-max(abs(hist_cent_degree_evol_outer{ti_EVOL})),max(abs(hist_cent_degree_evol_outer{ti_EVOL})),1000);
        degree_vec_hist_evol_outer_interp{ti_EVOL}=interp1(hist_cent_degree_evol_outer{ti_EVOL},degree_vec_hist_evol_outer{ti_EVOL},hist_cent_degree_evol_outer_interp{ti_EVOL},'cubic');
        degree_vec_hist_evol_outer_interp{ti_EVOL}(isnan(degree_vec_hist_evol_outer_interp{ti_EVOL})~=0)=0;

        [degree_vec_hist_max_evol_outer_interp{ti_EVOL},hist_max_ind_evol_outer_interp(ti_EVOL)]=max(degree_vec_hist_evol_outer_interp{ti_EVOL});
        degree_vec_hist_half_evol_outer_interp(ti_EVOL)=degree_vec_hist_max_evol_outer_interp{ti_EVOL}./2;
        [Y,hist_half_ind_L_evol_outer_interp(ti_EVOL)]=min(abs(degree_vec_hist_evol_outer_interp{ti_EVOL}(1:1:hist_max_ind_evol_outer_interp(ti_EVOL))-degree_vec_hist_half_evol_outer_interp(ti_EVOL)));
        [Y,hist_half_ind_R_temp_evol_outer_interp(ti_EVOL)]=min(abs(degree_vec_hist_evol_outer_interp{ti_EVOL}((hist_max_ind_evol_outer_interp(ti_EVOL)+1):1:end)-degree_vec_hist_half_evol_outer_interp(ti_EVOL)));
        hist_half_ind_R_evol_outer_interp(ti_EVOL)=hist_half_ind_R_temp_evol_outer_interp(ti_EVOL)+hist_max_ind_evol_outer_interp(ti_EVOL);
        asymmetry_fac_ind_evol_outer_interp(ti_EVOL)=(hist_half_ind_R_evol_outer_interp(ti_EVOL)-hist_max_ind_evol_outer_interp(ti_EVOL))./(hist_max_ind_evol_outer_interp(ti_EVOL)-hist_half_ind_L_evol_outer_interp(ti_EVOL));
        FWHM_evol_outer_interp(ti_EVOL)=hist_cent_degree_evol_outer_interp{ti_EVOL}(hist_half_ind_R_evol_outer_interp(ti_EVOL))-hist_cent_degree_evol_outer_interp{ti_EVOL}(hist_half_ind_L_evol_outer_interp(ti_EVOL));
    end

    save_file_name=['./Hist_Data/Hist_Data_Crystals_NN_',num2str(NN,'%05i'),'_k_max_',num2str(round(1e2.*km_ROI_max),'%03i'),'_min_',num2str(round(1e2.*km_ROI_min),'%03i')]
    save(save_file_name,'prefer_type','NN','km_ROI_max','km_ROI_min','NN_pre','NN_post','rng_arr_max','degree_max_global','hist_grid_global','degree_max_global_inner','hist_grid_global_inner','degree_max_global_outer','hist_grid_global_outer',...
        'hist_edge_degree_evol','hist_cent_degree_evol','degree_vec_hist_evol','hist_cent_degree_evol_inner','degree_vec_hist_evol_inner','hist_edge_degree_evol_outer','hist_cent_degree_evol_outer','degree_vec_hist_evol_outer',...
        'degree_vec_hist_max_evol','degree_vec_hist_half_evol','hist_half_ind_L_evol','hist_half_ind_R_evol','asymmetry_fac_ind_evol','FWHM_evol',...   % Main
        'hist_cent_degree_evol_interp','degree_vec_hist_evol_interp','degree_vec_hist_max_evol_interp','degree_vec_hist_half_evol_interp','hist_half_ind_L_evol_interp','hist_half_ind_R_evol_interp','asymmetry_fac_ind_evol_interp','FWHM_evol_interp',...
        'degree_vec_hist_max_evol_outer','degree_vec_hist_half_evol_outer','hist_half_ind_L_evol_outer','hist_half_ind_R_evol_outer','asymmetry_fac_ind_evol_outer','FWHM_evol_outer',...   % Outer
        'hist_cent_degree_evol_outer_interp','degree_vec_hist_evol_outer_interp','degree_vec_hist_max_evol_outer_interp','degree_vec_hist_half_evol_outer_interp','hist_half_ind_L_evol_outer_interp','hist_half_ind_R_evol_outer_interp','asymmetry_fac_ind_evol_outer_interp','FWHM_evol_outer_interp',...
        'degree_vec_hist_max_evol_inner','degree_vec_hist_half_evol_inner','hist_half_ind_L_evol_inner','hist_half_ind_R_evol_inner','asymmetry_fac_ind_evol_inner','FWHM_evol_inner',...   % Inner
        'hist_cent_degree_evol_inner_interp','degree_vec_hist_evol_inner_interp','degree_vec_hist_max_evol_inner_interp','degree_vec_hist_half_evol_inner_interp','hist_half_ind_L_evol_inner_interp','hist_half_ind_R_evol_inner_interp','asymmetry_fac_ind_evol_inner_interp','FWHM_evol_inner_interp',...
        'kk_range_set_min','kk_range_set_max','kk_ROI_min','kk_ROI_max','theta_cand_k','k_1D_abs','k_1D_theta','kk_range_set','k_1D_abs_sort','k_1D_theta_sort','abs_sort_ind','theta_sort_ind','SS_k_final_arr_1D','SS_k_final_arr_abs_sort','SS_k_final_arr_theta_sort',...
        'SS_k_evol_arr','SS_k_evol_inner_arr','SS_k_evol_outer_arr');

    % 'degree_vec_hist_max_evol_training','degree_vec_hist_half_evol_training','hist_half_ind_L_evol_training','hist_half_ind_R_evol_training','asymmetry_fac_ind_evol_training','FWHM_evol_training',... % Training
    % 'hist_cent_degree_evol_training_interp','degree_vec_hist_evol_training_interp','degree_vec_hist_max_evol_training_interp','degree_vec_hist_half_evol_training_interp','hist_half_ind_L_evol_training_interp','hist_half_ind_R_evol_training_interp','asymmetry_fac_ind_evol_training_interp','FWHM_evol_training_interp',...
    % 'degree_max_global_training','hist_grid_global_training',
    % 'hist_edge_degree_evol_training','hist_cent_degree_evol_training',
    % 'degree_vec_hist_evol_training','hist_edge_degree_evol_inner',
    % 'SS_k_evol_training_arr',
end

















