
%%

clear all;
close all;

NN=500;
km_ROI_max=0.5;
km_ROI_min=0.05;
NN_pre=1;
NN_post=0;

rng_arr_max=100;
load_file_name=['./Hist_Data/Hist_Set_Data_NN_',num2str(NN,'%05i'),'_k_max_',num2str(round(1e2.*km_ROI_max),'%03i'),'_min_',num2str(round(1e2.*km_ROI_min),'%03i'),'_NN_pre_',num2str(NN_pre,'%05i'),'_NN_post_',num2str(NN_post,'%05i')]   
load(load_file_name);

%% Plot Parameters
scatter_size=18;
scatter_alpha=0.8;
axis_SS_k=[0 2.3 0 2.3];
font_size=24;
font_size_2=21;

%% Case 1
plot_hist_ind_1=[2:1:6];
plot_hist_ind_2=[17:1:21];
case_PI_cent=2.5;
prefer_type_arr=[1,2,3,4,5,6,17,18,19,20,21];
% %% Case 2
% plot_hist_ind_1=[7:1:11];
% plot_hist_ind_2=[22:1:26];
% case_PI_cent=2.0;
% %% Case 3
% plot_hist_ind_1=[12:1:16];
% plot_hist_ind_2=[27:1:31];
% case_PI_cent=1.5;

clr_st_1=[0.9 0.2 0.2];
clr_ed_1=[0.9 0.9 0.2];

clr_st_2=[0.2 0.2 0.9];
clr_ed_2=[0.2 0.9 0.9];

for ti_post_type_hist=1:1:length(plot_hist_ind_1)
    prefer_type=plot_hist_ind_1(ti_post_type_hist);
    [Y,prefer_type_ind]=min(abs(prefer_type_arr-prefer_type));
    %% Scatter Plot
    fig_temp2=figure(4); hold on;
    SS_clr_plot=clr_st_1+(clr_ed_1-clr_st_1).*(ti_post_type_hist-1)./(length(plot_hist_ind_1)-1);
    ['prefer_type = ',num2str(prefer_type),', Color: ',num2str(SS_clr_plot)]
%     fig_scatter=scatter(SS_k_evol_arr_set(:,NN,prefer_type),SS_k_evol_outer_arr_set(:,NN,prefer_type),scatter_size,SS_clr_plot,'filled','v');
    fig_scatter=scatter(SS_k_evol_arr_set(:,NN,prefer_type_ind),SS_k_evol_outer_arr_set(:,NN,prefer_type_ind),scatter_size+3,SS_clr_plot,'filled','v');
    fig_scatter.MarkerFaceAlpha = scatter_alpha;    
end

for ti_post_type_hist=1:1:length(plot_hist_ind_2)
    prefer_type=plot_hist_ind_2(ti_post_type_hist);
    [Y,prefer_type_ind]=min(abs(prefer_type_arr-prefer_type));
    %% Scatter Plot
    fig_temp2=figure(4); hold on;
    SS_clr_plot=clr_st_2+(clr_ed_2-clr_st_2).*(ti_post_type_hist-1)./(length(plot_hist_ind_2)-1);
    ['prefer_type = ',num2str(prefer_type),', Color: ',num2str(SS_clr_plot)]
%     fig_scatter=scatter(SS_k_evol_arr_set(:,NN,prefer_type),SS_k_evol_outer_arr_set(:,NN,prefer_type),scatter_size,SS_clr_plot,'filled','^');
    fig_scatter=scatter(SS_k_evol_arr_set(:,NN,prefer_type_ind),SS_k_evol_outer_arr_set(:,NN,prefer_type_ind),scatter_size+3,SS_clr_plot,'filled','^');
    fig_scatter.MarkerFaceAlpha = scatter_alpha;    
end


%% SHU Final Plot %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
SS_clr_basic=[0.1 0.6 0.1];
fig_scatter=scatter(SS_k_evol_arr_set(:,NN,1),SS_k_evol_outer_arr_set(:,NN,1),scatter_size,SS_clr_basic,'filled','o','markeredgecolor',[0 0 0]);
% fig_scatter=scatter(SS_k_evol_arr_set(:,NN,1),SS_k_evol_outer_arr_set(:,NN,1),scatter_size,SS_clr_basic);
fig_scatter.MarkerFaceAlpha = scatter_alpha;
% 
% % Errorbar Plot
% hold on;
% mean_KK_ROI=mean(SS_k_evol_arr_set(:,NN,1));
% mean_KK_outer=mean(SS_k_evol_outer_arr_set(:,NN,1));
% std_KK_ROI=std(SS_k_evol_arr_set(:,NN,1));
% std_KK_outer=std(SS_k_evol_outer_arr_set(:,NN,1));
% errorbar(mean_KK_ROI,mean_KK_outer,2*std_KK_outer./2,2*std_KK_outer./2,2*std_KK_ROI./2,2*std_KK_ROI./2,'color',SS_clr_basic,'linewidth',1.5);
% 
% rr_temp=0.3*min([std_KK_ROI,std_KK_outer]);
% angle_temp=linspace(0,pi,50);
% plot(mean_KK_ROI+rr_temp.*cos(angle_temp),mean_KK_outer+rr_temp.*sin(angle_temp),'linestyle','-','linewidth',1.5,'color',SS_clr_basic);
% plot(mean_KK_ROI+rr_temp.*cos(angle_temp),mean_KK_outer-rr_temp.*sin(angle_temp),'linestyle','-','linewidth',1.5,'color',SS_clr_basic);

%% Poisson Final Plot %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
load('./Hist_Data\Hist_Data_Poisson_NN_00500_k_max_050_min_005.mat');
SS_clr_poisson=[0.2 0.2 0.2];
fig_scatter=scatter(SS_k_evol_arr(:,NN),SS_k_evol_outer_arr(:,NN),scatter_size,SS_clr_poisson,'filled','s');
fig_scatter.MarkerFaceAlpha = scatter_alpha;

% % Errorbar Plot
% hold on;
% mean_KK_ROI=mean(SS_k_evol_arr(:,NN));
% mean_KK_outer=mean(SS_k_evol_outer_arr(:,NN));
% std_KK_ROI=std(SS_k_evol_arr(:,NN));
% std_KK_outer=std(SS_k_evol_arr(:,NN));
% errorbar(mean_KK_ROI,mean_KK_outer,2*std_KK_outer./2,2*std_KK_outer./2,2*std_KK_ROI./2,2*std_KK_ROI./2,'color',[0 0 0],'linewidth',1.5);
% 
% rr_temp=0.3*min([std_KK_ROI,std_KK_outer]);
% angle_temp=linspace(0,pi,50);
% plot(mean_KK_ROI+rr_temp.*cos(angle_temp),mean_KK_outer+rr_temp.*sin(angle_temp),'linestyle','-','linewidth',1.5,'color',[0 0 0]);
% plot(mean_KK_ROI+rr_temp.*cos(angle_temp),mean_KK_outer-rr_temp.*sin(angle_temp),'linestyle','-','linewidth',1.5,'color',[0 0 0]);
%% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% [385, 401, 405, 408, 432, 440];
load('./Hist_Data\Hist_Data_Crystals_NN_00149_k_max_050_min_005.mat');
% fig_scatter=scatter(SS_k_evol_arr(:,NN),SS_k_evol_outer_arr(:,NN),scatter_size*30,SS_clr_basic,'s','filled');
fig_scatter.MarkerFaceAlpha = scatter_alpha;
plot(SS_k_evol_arr(:,NN),SS_k_evol_outer_arr(:,NN),'marker','x','markersize',15,'color',[0 0 0],'linewidth',2);

load('./Hist_Data\Hist_Data_Crystals_NN_00253_k_max_050_min_005.mat');
% fig_scatter=scatter(SS_k_evol_arr(:,NN),SS_k_evol_outer_arr(:,NN),scatter_size*30,SS_clr_basic,'s','filled');
fig_scatter.MarkerFaceAlpha = scatter_alpha;
plot(SS_k_evol_arr(:,NN),SS_k_evol_outer_arr(:,NN),'marker','x','markersize',15,'color',[0 0 0],'linewidth',2);
% 
load('./Hist_Data\Hist_Data_Crystals_NN_00377_k_max_050_min_005.mat');
% fig_scatter=scatter(SS_k_evol_arr(:,NN),SS_k_evol_outer_arr(:,NN),scatter_size*30,SS_clr_basic,'s','filled');
fig_scatter.MarkerFaceAlpha = scatter_alpha;
plot(SS_k_evol_arr(:,NN),SS_k_evol_outer_arr(:,NN),'marker','x','markersize',15,'color',[0 0 0],'linewidth',2);

load('./Hist_Data\Hist_Data_Crystals_NN_00385_k_max_050_min_005.mat');
% fig_scatter=scatter(SS_k_evol_arr(:,NN),SS_k_evol_outer_arr(:,NN),scatter_size*30,SS_clr_basic,'s','filled');
fig_scatter.MarkerFaceAlpha = scatter_alpha;
plot(SS_k_evol_arr(:,NN),SS_k_evol_outer_arr(:,NN),'marker','x','markersize',15,'color',[0 0 0],'linewidth',2);
load('./Hist_Data\Hist_Data_Crystals_NN_00401_k_max_050_min_005.mat');
% fig_scatter=scatter(SS_k_evol_arr(:,NN),SS_k_evol_outer_arr(:,NN),scatter_size*30,SS_clr_basic,'s','filled');
fig_scatter.MarkerFaceAlpha = scatter_alpha;
plot(SS_k_evol_arr(:,NN),SS_k_evol_outer_arr(:,NN),'marker','x','markersize',15,'color',[0 0 0],'linewidth',2);
% load('./Hist_Data\Hist_Data_Crystals_NN_00405_k_max_050_min_005.mat');
% % fig_scatter=scatter(SS_k_evol_arr(:,NN),SS_k_evol_outer_arr(:,NN),scatter_size*30,SS_clr_basic,'s','filled');
% fig_scatter.MarkerFaceAlpha = scatter_alpha;
% plot(SS_k_evol_arr(:,NN),SS_k_evol_outer_arr(:,NN),'marker','x','markersize',15,'color',[0 0 0],'linewidth',2);
load('./Hist_Data\Hist_Data_Crystals_NN_00408_k_max_050_min_005.mat');
% fig_scatter=scatter(SS_k_evol_arr(:,NN),SS_k_evol_outer_arr(:,NN),scatter_size*30,SS_clr_basic,'s','filled');
fig_scatter.MarkerFaceAlpha = scatter_alpha;
plot(SS_k_evol_arr(:,NN),SS_k_evol_outer_arr(:,NN),'marker','x','markersize',15,'color',[0 0 0],'linewidth',2);
load('./Hist_Data\Hist_Data_Crystals_NN_00432_k_max_050_min_005.mat');
% fig_scatter=scatter(SS_k_evol_arr(:,NN),SS_k_evol_outer_arr(:,NN),scatter_size*30,SS_clr_basic,'s','filled');
fig_scatter.MarkerFaceAlpha = scatter_alpha;
plot(SS_k_evol_arr(:,NN),SS_k_evol_outer_arr(:,NN),'marker','x','markersize',15,'color',[0 0 0],'linewidth',2);
% load('./Hist_Data\Hist_Data_Crystals_NN_00440_k_max_050_min_005.mat');
% % fig_scatter=scatter(SS_k_evol_arr(:,NN),SS_k_evol_outer_arr(:,NN),scatter_size*30,SS_clr_basic,'s','filled');
% fig_scatter.MarkerFaceAlpha = scatter_alpha;
% plot(SS_k_evol_arr(:,NN),SS_k_evol_outer_arr(:,NN),'marker','x','markersize',15,'color',[0 0 0],'linewidth',2);

load('./Hist_Data\Hist_Data_Crystals_NN_00529_k_max_050_min_005.mat');
% fig_scatter=scatter(SS_k_evol_arr(:,NN),SS_k_evol_outer_arr(:,NN),scatter_size*30,SS_clr_basic,'s','filled');
fig_scatter.MarkerFaceAlpha = scatter_alpha;
plot(SS_k_evol_arr(:,NN),SS_k_evol_outer_arr(:,NN),'marker','x','markersize',15,'color',[0 0 0],'linewidth',2);

% load('./Hist_Data\Hist_Data_Crystals_NN_00113_k_max_050_min_005.mat');
% % fig_scatter=scatter(SS_k_evol_arr(:,NN),SS_k_evol_outer_arr(:,NN),scatter_size*30,SS_clr_basic,'s','filled');
% fig_scatter.MarkerFaceAlpha = scatter_alpha;
% plot(SS_k_evol_arr(:,NN),SS_k_evol_outer_arr(:,NN),'marker','x','markersize',12,'color',[0 0 0],'linewidth',1.5);
% % 
% % load('./Hist_Data\Hist_Data_Crystals_NN_00377_k_max_050_min_005.mat');
% % fig_scatter=scatter(SS_k_evol_arr(:,NN),SS_k_evol_outer_arr(:,NN),scatter_size*30,SS_clr_basic,'s','filled');
% % fig_scatter.MarkerFaceAlpha = scatter_alpha;
    
box on;
axis(axis_SS_k);
hx=xlabel('<{\itS_n}>{\bf_K} ({\bfK} = {\bfK_L})');
% hy=ylabel('<{\itS_n}>{\bf_K}, <{\itS_n}>{\bf_K}^c');
hy=ylabel('<{\itS_n}>{\bf_K} ({\bfK} = {\bfK_S})');
h=gca;
set(h,'Fontname','Helvetica','FontWeight','normal','xtick',[0:1:10],'ytick',[0:1:10],'FontSize',font_size_2,'PlotBoxAspectRatio',[1 1 1],'linewidth',1,'xscale','linear');
set(hx,'Fontname','Helvetica','FontWeight','normal','FontSize',font_size);
set(hy,'Fontname','Helvetica','FontWeight','normal','FontSize',font_size);
movegui(fig_temp2,'west');

folder_name_fig=['./Fig_S_Factor_LS'];
mkdir(folder_name_fig);
figure(4);
file_name_4=[folder_name_fig,'/Fig_S_Final_Set_',num2str(round(case_PI_cent*100),'%05i'),'.tif']
save_fig = gcf;
set(save_fig, 'Position',  [100, 30, 800, 900]);
exportgraphics(save_fig,file_name_4,'Resolution',500);
% 
% inset_L=0.05; inset_R=0.22; inset_B=0.7; inset_U=1.5;
% % patch([inset_L inset_R inset_R inset_L inset_L],[inset_B inset_B inset_U inset_U inset_B],[0 0 0 0 0],'linewidth',1,'linestyle','-','facealpha',0.0,'edgecolor',[0 0 0]);
% hold on; box_clr=[0 0 0]; box_line_width=1;
% plot([inset_L inset_R],[inset_B inset_B],'color',box_clr,'linewidth',box_line_width);
% plot([inset_L inset_R],[inset_U inset_U],'color',box_clr,'linewidth',box_line_width);
% plot([inset_L inset_L],[inset_B inset_U],'color',box_clr,'linewidth',box_line_width);
% plot([inset_R inset_R],[inset_B inset_U],'color',box_clr,'linewidth',box_line_width);
% h=gca;
% set(h,'Fontname','Helvetica','FontWeight','normal','xtick',[0:1:10],'ytick',[0:1:10],'FontSize',font_size_2,'PlotBoxAspectRatio',[1 1 1],'linewidth',1,'xscale','linear');
% set(hx,'Fontname','Helvetica','FontWeight','normal','FontSize',font_size);
% set(hy,'Fontname','Helvetica','FontWeight','normal','FontSize',font_size);
% file_name_5=[folder_name_fig,'/Fig_S_Final_Set_box_',num2str(round(case_PI_cent*100),'%05i'),'.tif']
% save_fig = gcf;
% set(save_fig, 'Position',  [100, 30, 800, 900]);
% exportgraphics(save_fig,file_name_5,'Resolution',500);
% 
% h=gca;
% axis([inset_L inset_R inset_B inset_U]);
% set(h,'Fontname','Helvetica','FontWeight','normal','xtick',[0:0.1:10],'ytick',[0:0.1:10],'FontSize',font_size_2,'PlotBoxAspectRatio',[1 1 1],'linewidth',1,'xscale','linear');
% % set(h,'Fontname','Helvetica','FontWeight','normal','xtick',[0:1:10],'ytick',[0:1:10],'FontSize',font_size_2,'PlotBoxAspectRatio',[1 1 1],'linewidth',1,'xscale','linear');
% set(hx,'Fontname','Helvetica','FontWeight','normal','FontSize',font_size);
% set(hy,'Fontname','Helvetica','FontWeight','normal','FontSize',font_size);
% file_name_6=[folder_name_fig,'/Fig_S_Final_Set_Inset_',num2str(round(case_PI_cent*100),'%05i'),'.tif']
% save_fig = gcf;
% set(save_fig, 'Position',  [100, 30, 800, 900]);
% exportgraphics(save_fig,file_name_6,'Resolution',500);
% 
% axis off;
% file_name_7=[folder_name_fig,'/Fig_S_Final_Set_',num2str(round(case_PI_cent*100),'%05i'),'_Inset_Axis_Off','.tif']
% save_fig = gcf;
% set(save_fig, 'Position',  [100, 30, 800, 900]);
% exportgraphics(save_fig,file_name_7,'Resolution',500);
% 


















        